package net.afyre.haha.demo.solver.context;

/**
 * Description of a symbol or axiom declaration.
 * 
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 */
public interface Declaration {
  /**
   * Use a visitor to decompose this declaration.
   * @param visitor Visitor object.
   */
  void accept(DeclarationVisitor visitor);
  
  /**
   * Get name of the declared symbol or axiom.
   * @return Name.
   */
  String getName();
}
