package net.afyre.haha.demo.solver.context;

import net.afyre.haha.demo.solver.expr.terms.Term;
import net.afyre.haha.demo.solver.expr.types.ValueType;

/**
 * Declaration or definition of a variable for function.
 * 
 * @author Aleksy Schubert <alx@mimuw.edu.pl>
 */
public final class FuncResultDeclaration extends TermDeclaration {


  /**
   * Create a variable for function declaration.
   * @param name Function name.
   * @param type Function result type.
   */
  public FuncResultDeclaration(final String name,
                         final ValueType type) {
    super(name, type);
  }
  
  /**
   * Create a variable for function definition.
   * @param name Function name.
   * @param type Function type.
   * @param value Function definition (null for declarations).
   */
  public FuncResultDeclaration(final String name,
                         final ValueType type,
                         final Term value) {
    super(name, type, value);
  }
  
}
