package net.afyre.haha.demo.solver.expr.formulae.impl;

import net.afyre.haha.demo.solver.expr.formulae.Formula;

/**
 * Abstract superclass of binary formulae.
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 */
public abstract class BinaryFormula extends AbstractFormula {
  /** Left subformula. */
  private final Formula left;
  
  /** Right subformula. */
  private final Formula right;
  
  /**
   * Constructor.
   * @param left Left subformula.
   * @param right Right subformula.
   */
  protected BinaryFormula(final Formula left, 
                          final Formula right) {
    this.left = left;
    this.right = right;
  }

  /**
   * Get the left subformula.
   * @return The left subformula.
   */
  public Formula getLeft() {
    return left;
  }

  /**
   * Get the right subformula.
   * @return The right subformula.
   */
  public Formula getRight() {
    return right;
  }
}
