package net.afyre.haha.demo.solver.expr.formulae.impl;

import net.afyre.haha.demo.solver.expr.formulae.Formula;
import net.afyre.haha.demo.solver.expr.formulae.FormulaSwitch;

/**
 * Conjunction.
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 */
public class Conjunction extends BinaryFormula {
  /**
   * Constructor.
   * @param left Left subformula.
   * @param right Right subformula.
   */
  public Conjunction(final Formula left, final Formula right) {
    super(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public<Result> Result accept(final FormulaSwitch<? extends Result> v) {
    return v.caseConjunction(getLeft(), getRight());
  }
}
