/**
 * 
 */
package net.afyre.haha.demo.solver.expr.formulae.impl;

import net.afyre.haha.demo.solver.expr.formulae.Formula;
import net.afyre.haha.demo.solver.expr.formulae.FormulaSwitch;

/**
 * Logical negation.
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 */
public final class Negation extends AbstractFormula {
  /** Argument. */
  private final Formula argument;
  
  /**
   * Constructor.
   * @param argument Argument.
   */
  public Negation(final Formula argument) {
    this.argument = argument;
  }
  
  /**
   * Get the argument.
   * @return Argument.
   */
  public Formula getArgument() {
    return argument;
  }

  /** {@inheritDoc} */
  @Override
  public<Result> Result accept(final FormulaSwitch<? extends Result> v) {
    return v.caseNegation(argument);
  }
}
