package net.afyre.haha.demo.solver.expr.terms.impl;

import net.afyre.haha.demo.solver.expr.ExpressionSwitch;
import net.afyre.haha.demo.solver.expr.impl.AbstractExpression;
import net.afyre.haha.demo.solver.expr.terms.Term;
import net.afyre.haha.demo.solver.expr.terms.TermSwitch;

/**
 * Abstract superclass of terms.
 * 
 * Implements forwarding of accept calls for supertypes.
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 */
public abstract class AbstractTerm extends AbstractExpression
                                   implements Term {
  /** {@inheritDoc} */
  @Override
  public<Result> Result accept(final ExpressionSwitch<? extends Result> v) {
    return accept((TermSwitch<? extends Result>)v);
  }
}
