package net.afyre.haha.demo.solver.expr.terms.impl;

import net.afyre.haha.demo.solver.expr.terms.Term;

/**
 * Abstract superclass of binary operators on terms.
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 */
public abstract class BinaryTerm extends AbstractTerm {
  /** Left operand. */
  private final Term left;
  
  /** Right operand. */
  private final Term right;

  /**
   * Constructor.
   * @param left Left operand.
   * @param right Right operand.
   */
  protected BinaryTerm(final Term left, final Term right) {
    this.left = left;
    this.right = right;
  }

  /**
   * Get the left operand.
   * @return The left operand.
   */
  public Term getLeft() {
    return left;
  }

  /**
   * Get the right operand.
   * @return The right operand.
   */
  public Term getRight() {
    return right;
  }
}
