package net.afyre.haha.demo.solver.expr.terms.impl;

import java.math.BigInteger;

import net.afyre.haha.demo.solver.expr.terms.TermSwitch;

/**
 * Integer literal.
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 */
public final class IntConst extends AbstractTerm {
  /** Literal value. */
  private final BigInteger value;
  
  /**
   * Constructor.
   * @param value Literal value.
   */
  public IntConst(final BigInteger value) {
    this.value = value;
  }
  
  /**
   * Get the literal value.
   * @return Value.
   */
  public BigInteger getValue() {
    return value;
  }

  /** {@inheritDoc} */
  @Override
  public<Result> Result accept(final TermSwitch<? extends Result> v) {
    return v.caseIntConst(value);
  }
}
