package net.afyre.haha.demo.solver.expr.terms.impl;

import java.util.Arrays;

import net.afyre.haha.demo.solver.expr.terms.Term;
import net.afyre.haha.demo.solver.expr.terms.TermSwitch;

/**
 * Tuple construction.
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 */
public final class MkTuple extends AbstractTerm {
  /** Tuple elements. */
  private final Term[] elements;
  
  /**
   * Constructor.
   * @param elements Tuple elements.
   */
  public MkTuple(final Term... elements) {
    this.elements = Arrays.copyOf(elements, elements.length);
  }
  
  /**
   * Get elements of this tuple.
   * @return Tuple elements.
   */
  public Term[] getElements() {
    return Arrays.copyOf(elements, elements.length);
  }

  /** {@inheritDoc} */
  @Override
  public<Result> Result accept(final TermSwitch<? extends Result> v) {
    return v.caseMkTuple(getElements());
  }
}
