package net.afyre.haha.demo.solver.expr.terms.impl;

import net.afyre.haha.demo.solver.expr.terms.Term;
import net.afyre.haha.demo.solver.expr.terms.TermSwitch;

/**
 * Vector signed less than or equal to.
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 * @see net.afyre.haha.demo.solver.expr.terms.TermSwitch#visitVectorSle
 */
public final class VectorSle extends BinaryTerm {
  /**
   * Constructor.
   * @param left Left operand.
   * @param right Right operand.
   */
  public VectorSle(final Term left, final Term right) {
    super(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public<Result> Result accept(final TermSwitch<? extends Result> v) {
    return v.caseVectorSle(getLeft(), getRight());
  }
}
