package net.afyre.haha.demo.solver.expr.types;

/**
 * Interface of objects used to deconstruct non-value types.
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 * @param <Result> Type of objects returned by visitor methods.
 */
public interface NonValueTypeSwitch<Result> {
  /** 
   * Type of propositions. 
   * @return Switch result. 
   **/
  Result caseProp();
  
  /** 
   * Type of functions.
   * @param resultType Result type (codomain).
   * @param argTypes Argument types (domain).
   * @return Switch result. 
   **/
  Result caseFunction(ValueType resultType, ValueType... argTypes);
  
  /** 
   * Type of predicates.
   * @param argTypes Argument types (domain).
   * @return Switch result. 
   **/
  Result casePredicate(ValueType... argTypes);
}
