package net.afyre.haha.demo.solver.expr.types;

/**
 * Interface of objects used to deconstruct structured types.
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 * @param <Result> Type of objects returned by visitor methods.
 */
public interface StructuredTypeSwitch<Result> {
  /** 
   * Array type. 
   * @param indexType Type of indices.
   * @param valueType Type of values.
   * @return Switch result. 
   **/
  Result caseArray(ValueType indexType, ValueType valueType);
  
  /**
   * Tuple type.
   * @param types Component types.
   * @return Switch result. 
   **/
  Result caseTuple(ValueType... types);
  
  /** TODO: Record types and inductive types. */
}
