package net.afyre.haha.demo.solver.expr.types.impl;

import net.afyre.haha.demo.solver.expr.types.StructuredType;
import net.afyre.haha.demo.solver.expr.types.StructuredTypeSwitch;
import net.afyre.haha.demo.solver.expr.types.ValueTypeSwitch;

/**
 * Abstract superclass of structured types.
 * 
 * Implements forwarding of accept calls for supertypes.
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 */
public abstract class AbstractStructuredType extends AbstractValueType 
                                             implements StructuredType {
  /** {@inheritDoc} */
  @Override
  public<Result> Result accept(final ValueTypeSwitch<? extends Result> v) {
    return accept((StructuredTypeSwitch<? extends Result>)v);
  }
}
