package net.afyre.haha.demo.testsutils;


import net.afyre.haha.demo.HahaStandaloneSetup;

import org.eclipse.xtext.junit4.GlobalRegistries;
import org.eclipse.xtext.junit4.GlobalRegistries.GlobalStateMemento;
import org.eclipse.xtext.junit4.IInjectorProvider;
import org.eclipse.xtext.junit4.IRegistryConfigurator;

import com.google.inject.Injector;


public class HahaTestsInjectorProvider implements IInjectorProvider, IRegistryConfigurator {

  private GlobalStateMemento globalStateMemento;
  private Injector injector;

  static {
    GlobalRegistries.initializeDefaults();
  }
  
  public Injector getInjector() {
    if (injector == null) {
      this.injector = new HahaStandaloneSetup().createInjectorAndDoEMFRegistration();
    }
    return injector;
  }
  
  public void restoreRegistry() {
    globalStateMemento.restoreGlobalState();
  }

  public void setupRegistry() {
    globalStateMemento = GlobalRegistries.makeCopyOfGlobalState();
  }


}