package net.afyre.haha.demo.ui.handler;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.commands.IHandler;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.handlers.HandlerUtil;

import net.afyre.haha.demo.ui.vcview.VerificationConditionsView;

/**
 * The class implements the command to show the Verification Conditions
 * view.
 *  
 * @author Aleksy Schubert <alx@mimuw.edu.pl>
 *
 */
public class VCViewShowHandler extends AbstractHandler implements IHandler {

  /**
   * The method retrieves the id for the verification conditions view and opens 
   * it in the view of the current event.
   */
  @Override
  public Object execute(final ExecutionEvent event) throws ExecutionException {
    final Shell shell = HandlerUtil.getActiveShellChecked(event);
    final IWorkbenchWindow window = HandlerUtil
        .getActiveWorkbenchWindowChecked(event);
    final IWorkbenchPage page = window.getActivePage();
    final String id = VerificationConditionsView.ID;
    try {
      page.showView(id);
    } catch (final PartInitException e) {
      final MessageBox dialog = new MessageBox(shell, SWT.OK);
      dialog.setMessage("Cannot show the Verification Conditions view");
      dialog.open();
    }
    return null;
  }
}
