package net.afyre.haha.demo.ui.hover;

import org.eclipse.jface.action.ToolBarManager;
import org.eclipse.jface.text.AbstractInformationControl;
import org.eclipse.jface.text.IInformationControlExtension2;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Shell;

/**
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 *
 */
public class HahaInformationControl 
   extends AbstractInformationControl 
   implements IInformationControlExtension2  {

  private HahaMarkerInformation info;
  
  //private Composite parentControl;
  
  public HahaInformationControl(final Shell parentShell, 
                                final String statusFieldText) {
    super(parentShell, statusFieldText);
    create();
  }

  public HahaInformationControl(final Shell parentShell, 
                                final ToolBarManager toolBarManager) {
    super(parentShell, toolBarManager);
    create();
  }

  public HahaInformationControl(final Shell parentShell, 
                                final boolean resizeable) {
    super(parentShell, resizeable);
    create();
  }   
  

  /*
   * @see org.eclipse.jface.text.IInformationControl#setInformation(java.lang.String)
   */
  @Override
  public void setInformation(final String information) {
      //replaced by IInformationControlExtension2#setInput
  }
  
  /** {@inheritDoc} */
  @Override
  public boolean hasContents() {
    return info != null;
  }

  /** {@inheritDoc} */
  @Override
  public void setInput(final Object input) {
    if (input instanceof HahaMarkerInformation) {
      info = (HahaMarkerInformation)input;
    }
  }

  /** {@inheritDoc} */
  @Override
  protected void createContent(final Composite parent) {
    //parentControl = parent;
//    final GridLayout layout= new GridLayout(1, false);
//    layout.verticalSpacing = 0;
//    layout.marginWidth = 0;
//    layout.marginHeight = 0;
//    parentControl.setLayout(layout);
    final Composite composite = new Composite(parent, SWT.NONE);
    final RowLayout layout = new RowLayout(SWT.VERTICAL);
    composite.setLayout(layout);
    
    new Button(composite, SWT.PUSH).setText("DUPA");
    new Button(composite, SWT.PUSH).setText("BLADA");
  }
}
