/*
* generated by Xtext
*/
package net.afyre.haha.demo.ui.labeling;

import java.util.ArrayList;
import java.util.List;

import net.afyre.haha.demo.haha.Argument;
import net.afyre.haha.demo.haha.Assertion;
import net.afyre.haha.demo.haha.Axiom;
import net.afyre.haha.demo.haha.ExistsVar;
import net.afyre.haha.demo.haha.Expression;
import net.afyre.haha.demo.haha.ForallVar;
import net.afyre.haha.demo.haha.Function;
import net.afyre.haha.demo.haha.Local;
import net.afyre.haha.demo.haha.Postcondition;
import net.afyre.haha.demo.haha.Precondition;
import net.afyre.haha.demo.haha.Predicate;
import net.afyre.haha.demo.haha.ResultVar;
import net.afyre.haha.demo.haha.Variable;
import net.afyre.haha.demo.ui.util.Utils;

import org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider;
import org.eclipse.jface.viewers.StyledString;
import org.eclipse.xtext.ui.label.DefaultEObjectLabelProvider;

import com.google.common.base.Joiner;
import com.google.inject.Inject;

/**
 * Provides labels for a EObjects.
 * 
 * see http://www.eclipse.org/Xtext/documentation/latest/xtext.html#labelProvider
 */
public class HahaLabelProvider extends DefaultEObjectLabelProvider {
  //@Inject 
  //private StylerFactory stylerFactory;
  
  @Inject
  public HahaLabelProvider(AdapterFactoryLabelProvider delegate) {
    super(delegate);
  }

  String image(final Local var) {
    return "local-16x16.gif";
  }

  String image(final Argument arg) {
    return "argument-16x16.gif";
  }

  String image(final ExistsVar var) {
    return "existsvar-16x16.gif";
  }

  String image(final ForallVar var) {
    return "forallvar-16x16.gif";
  }

  String image(final ResultVar var) {
	    return "resultvar-16x16.gif";
	  }
  
  String image(final Function func) {
    return "function-16x16.gif";
  }

  String image(final Predicate pred) {
    return "predicate-16x16.gif";
  }

  String image(final Precondition pre) {
    return "pre-16x16.gif";
  }
  
  String image(final Postcondition post) {
    return "post-16x16.gif";
  }
  
  String image(final Assertion assertion) {
    return "assert-16x16.gif";
  }

  String image(final Axiom axiom) {
    return "axiom-16x16.gif";
  }
  
  StyledString text(final Variable var) {
    final StyledString result = new StyledString(var.getName());
    result.append(" : ");
    result.append(Utils.typeToString(var.getType()), 
        StyledString.QUALIFIER_STYLER);
    return result;
  }
  
  StyledString text(final Function function) {
    final StyledString result = new StyledString(function.getName());
    final Joiner joiner = Joiner.on(" → ");
    final List<String> types = new ArrayList<String>();

    for (final Argument arg : function.getArguments().getArguments()) {
      types.add(Utils.typeToString(arg.getType()));
    }
    types.add(Utils.typeToString(function.getResultType()));
    result.append(new StyledString(
        " : " + joiner.join(types), 
        StyledString.QUALIFIER_STYLER));
    return result;
  }

  StyledString text(final Predicate predicate) {
    final StyledString result = new StyledString(predicate.getName());
    final Joiner joiner = Joiner.on(" → ");
    final List<String> types = new ArrayList<String>();

    for (final Argument arg : predicate.getArguments().getArguments()) {
      types.add(Utils.typeToString(arg.getType()));
    }
    types.add("BOOL");
    result.append(new StyledString(
        " : " + joiner.join(types), 
        StyledString.QUALIFIER_STYLER));
    return result;
  }

  String text(final Precondition pre) {
    final String prefix;
    
    if (pre == null) { return null; }
    
    if (pre.getName() != null) {
      prefix = pre.getName() + " : ";
    } else {
      prefix = "";
    }
    final String code = exprToString(pre.getFormula());
    return prefix + code;
  }

  String text(final Postcondition post) {
    final String prefix;
    
    if (post == null) { return null; }
    
    if (post.getName() != null) {
      prefix = post.getName() + " : ";
    } else {
      prefix = "";
    }
    final String code = exprToString(post.getFormula());
    return prefix + code;
  }
  
  String text(final Axiom axiom) {
    final String prefix;
    
    if (axiom == null) { return null; }
    
    if (axiom.getName() != null) {
      prefix = axiom.getName() + " : ";
    } else {
      prefix = "";
    }
    final String code = exprToString(axiom.getFormula());
    return prefix + code;
  }
  
  String exprToString(final Expression expr) {
    String code;
    try {
      code = Utils.serialize(expr);
    } catch (final Exception e) {
      code = "???";
    }
    
    return code;
  }
  
/*
	//Labels and icons can be computed like this:
	
	String text(MyModel ele) {
	  return "my "+ele.getName();
	}
	 
    String image(MyModel ele) {
      return "MyModel.gif";
    }
*/
}
