package net.afyre.haha.demo.util;

/**
 * Base class for hash builders.
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 */
public abstract class AbstractHashBuilder implements HashBuilder {
  /** Octet size in bits. */
  private static final int OCTET_SIZE = 8;
  
  /** Constructor. */
  protected AbstractHashBuilder() { }
  
  /** 
   * Default implementation of appendInt (using appendByte).
   * Subclasses may override this for efficiency.
   * @param i Integer to be appended.
   */
  @Override
  public void appendInt(final int i) {
    int offset = 0;

    appendByte((byte)((i >>> offset) & 0xff));
    offset += OCTET_SIZE;
    
    appendByte((byte)((i >>> offset) & 0xff));
    offset += OCTET_SIZE;
    
    appendByte((byte)((i >>> offset) & 0xff));
    offset += OCTET_SIZE;
    
    appendByte((byte)((i >>> offset) & 0xff)); 
  }
}
