package net.afyre.haha.demo.types;

/**
 * Interface of HAHA types.
 * 
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 */
public interface Type {
  /**
   * Deconstruct this type using a switch.
   * 
   * @param <Result> Type of objects returned by the switch.
   * @param sw Switch object.
   * @return Object returned by the switch.
   */
  <Result> Result doSwitch(TypeSwitch<? extends Result> sw);
}
