package net.afyre.haha.demo.vcgen.tree;

/**
 * Abstract superclass implementing basic functionality of a {@link node}.
 * 
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 */
public abstract class AbstractNode implements Node {
  /** Parent node. */
  private final Node parent;
  
  /**
   * Constructor.
   * @param parent Parent node, use {@code null} to create the root node.
   */
  public AbstractNode(final Node parent) {
    this.parent = parent;
  }
  
  /** {@inheritDoc} */
  @Override
  public Node getParent() {
    return parent;
  }
}
