/**
 */
package net.afyre.haha.demo.haha;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see net.afyre.haha.demo.haha.HahaFactory
 * @model kind="package"
 * @generated
 */
public interface HahaPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "haha";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.afyre.net/haha/demo/Haha";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "haha";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	HahaPackage eINSTANCE = net.afyre.haha.demo.haha.impl.HahaPackageImpl.init();

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.ProgramImpl <em>Program</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.ProgramImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getProgram()
	 * @generated
	 */
	int PROGRAM = 0;

	/**
	 * The feature id for the '<em><b>Predicates</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROGRAM__PREDICATES = 0;

	/**
	 * The feature id for the '<em><b>Functions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROGRAM__FUNCTIONS = 1;

	/**
	 * The feature id for the '<em><b>Axioms</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROGRAM__AXIOMS = 2;

	/**
	 * The number of structural features of the '<em>Program</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROGRAM_FEATURE_COUNT = 3;

	/**
	 * The number of operations of the '<em>Program</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROGRAM_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.CallableImpl <em>Callable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.CallableImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getCallable()
	 * @generated
	 */
	int CALLABLE = 56;

	/**
	 * The feature id for the '<em><b>Arguments</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLABLE__ARGUMENTS = 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLABLE__NAME = 1;

	/**
	 * The number of structural features of the '<em>Callable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLABLE_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Callable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLABLE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.PredicateImpl <em>Predicate</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.PredicateImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getPredicate()
	 * @generated
	 */
	int PREDICATE = 1;

	/**
	 * The feature id for the '<em><b>Arguments</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PREDICATE__ARGUMENTS = CALLABLE__ARGUMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PREDICATE__NAME = CALLABLE__NAME;

	/**
	 * The feature id for the '<em><b>Formula</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PREDICATE__FORMULA = CALLABLE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Predicate</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PREDICATE_FEATURE_COUNT = CALLABLE_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Predicate</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PREDICATE_OPERATION_COUNT = CALLABLE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.FunctionImpl <em>Function</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.FunctionImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getFunction()
	 * @generated
	 */
	int FUNCTION = 2;

	/**
	 * The feature id for the '<em><b>Arguments</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION__ARGUMENTS = CALLABLE__ARGUMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION__NAME = CALLABLE__NAME;

	/**
	 * The feature id for the '<em><b>Result Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION__RESULT_TYPE = CALLABLE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Docs</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION__DOCS = CALLABLE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Preconditions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION__PRECONDITIONS = CALLABLE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Postconditions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION__POSTCONDITIONS = CALLABLE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Locals</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION__LOCALS = CALLABLE_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Body</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION__BODY = CALLABLE_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Result Var</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION__RESULT_VAR = CALLABLE_FEATURE_COUNT + 6;

	/**
	 * The number of structural features of the '<em>Function</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION_FEATURE_COUNT = CALLABLE_FEATURE_COUNT + 7;

	/**
	 * The operation id for the '<em>Result Var</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION___RESULT_VAR = CALLABLE_OPERATION_COUNT + 0;

	/**
	 * The number of operations of the '<em>Function</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION_OPERATION_COUNT = CALLABLE_OPERATION_COUNT + 1;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.ArgumentListImpl <em>Argument List</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.ArgumentListImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getArgumentList()
	 * @generated
	 */
	int ARGUMENT_LIST = 3;

	/**
	 * The feature id for the '<em><b>Arguments</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARGUMENT_LIST__ARGUMENTS = 0;

	/**
	 * The number of structural features of the '<em>Argument List</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARGUMENT_LIST_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Argument List</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARGUMENT_LIST_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.Variable <em>Variable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.Variable
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getVariable()
	 * @generated
	 */
	int VARIABLE = 59;

	/**
	 * The number of structural features of the '<em>Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_FEATURE_COUNT = 0;

	/**
	 * The operation id for the '<em>Get Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE___GET_TYPE = 0;

	/**
	 * The operation id for the '<em>Get Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE___GET_NAME = 1;

	/**
	 * The number of operations of the '<em>Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_OPERATION_COUNT = 2;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.DeclaredVariableImpl <em>Declared Variable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.DeclaredVariableImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getDeclaredVariable()
	 * @generated
	 */
	int DECLARED_VARIABLE = 25;

	/**
	 * The feature id for the '<em><b>Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECLARED_VARIABLE__TYPE = VARIABLE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECLARED_VARIABLE__NAME = VARIABLE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Declared Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECLARED_VARIABLE_FEATURE_COUNT = VARIABLE_FEATURE_COUNT + 2;

	/**
	 * The operation id for the '<em>Get Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECLARED_VARIABLE___GET_TYPE = VARIABLE___GET_TYPE;

	/**
	 * The operation id for the '<em>Get Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECLARED_VARIABLE___GET_NAME = VARIABLE___GET_NAME;

	/**
	 * The number of operations of the '<em>Declared Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECLARED_VARIABLE_OPERATION_COUNT = VARIABLE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.ArgumentImpl <em>Argument</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.ArgumentImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getArgument()
	 * @generated
	 */
	int ARGUMENT = 4;

	/**
	 * The feature id for the '<em><b>Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARGUMENT__TYPE = DECLARED_VARIABLE__TYPE;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARGUMENT__NAME = DECLARED_VARIABLE__NAME;

	/**
	 * The feature id for the '<em><b>Doc</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARGUMENT__DOC = DECLARED_VARIABLE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Argument</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARGUMENT_FEATURE_COUNT = DECLARED_VARIABLE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Get Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARGUMENT___GET_TYPE = DECLARED_VARIABLE___GET_TYPE;

	/**
	 * The operation id for the '<em>Get Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARGUMENT___GET_NAME = DECLARED_VARIABLE___GET_NAME;

	/**
	 * The number of operations of the '<em>Argument</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARGUMENT_OPERATION_COUNT = DECLARED_VARIABLE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.PreconditionImpl <em>Precondition</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.PreconditionImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getPrecondition()
	 * @generated
	 */
	int PRECONDITION = 5;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRECONDITION__NAME = 0;

	/**
	 * The feature id for the '<em><b>Formula</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRECONDITION__FORMULA = 1;

	/**
	 * The number of structural features of the '<em>Precondition</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRECONDITION_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Precondition</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRECONDITION_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.PostconditionImpl <em>Postcondition</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.PostconditionImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getPostcondition()
	 * @generated
	 */
	int POSTCONDITION = 6;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POSTCONDITION__NAME = 0;

	/**
	 * The feature id for the '<em><b>Formula</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POSTCONDITION__FORMULA = 1;

	/**
	 * The number of structural features of the '<em>Postcondition</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POSTCONDITION_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Postcondition</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POSTCONDITION_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.LocalsImpl <em>Locals</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.LocalsImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getLocals()
	 * @generated
	 */
	int LOCALS = 7;

	/**
	 * The feature id for the '<em><b>Variables</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOCALS__VARIABLES = 0;

	/**
	 * The number of structural features of the '<em>Locals</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOCALS_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Locals</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOCALS_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.LocalImpl <em>Local</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.LocalImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getLocal()
	 * @generated
	 */
	int LOCAL = 8;

	/**
	 * The feature id for the '<em><b>Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOCAL__TYPE = DECLARED_VARIABLE__TYPE;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOCAL__NAME = DECLARED_VARIABLE__NAME;

	/**
	 * The feature id for the '<em><b>Doc</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOCAL__DOC = DECLARED_VARIABLE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Local</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOCAL_FEATURE_COUNT = DECLARED_VARIABLE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Get Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOCAL___GET_TYPE = DECLARED_VARIABLE_OPERATION_COUNT + 0;

	/**
	 * The operation id for the '<em>Get Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOCAL___GET_NAME = DECLARED_VARIABLE_OPERATION_COUNT + 1;

	/**
	 * The number of operations of the '<em>Local</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOCAL_OPERATION_COUNT = DECLARED_VARIABLE_OPERATION_COUNT + 2;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.TypeImpl <em>Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.TypeImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getType()
	 * @generated
	 */
	int TYPE = 9;

	/**
	 * The number of structural features of the '<em>Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_FEATURE_COUNT = 0;

	/**
	 * The operation id for the '<em>As String</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE___AS_STRING = 0;

	/**
	 * The number of operations of the '<em>Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_OPERATION_COUNT = 1;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.SimpleTypeImpl <em>Simple Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.SimpleTypeImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getSimpleType()
	 * @generated
	 */
	int SIMPLE_TYPE = 10;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_TYPE__TYPE = TYPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Simple Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_TYPE_FEATURE_COUNT = TYPE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>As String</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_TYPE___AS_STRING = TYPE_OPERATION_COUNT + 0;

	/**
	 * The number of operations of the '<em>Simple Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_TYPE_OPERATION_COUNT = TYPE_OPERATION_COUNT + 1;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.ArrayTypeImpl <em>Array Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.ArrayTypeImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getArrayType()
	 * @generated
	 */
	int ARRAY_TYPE = 11;

	/**
	 * The feature id for the '<em><b>Element Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_TYPE__ELEMENT_TYPE = TYPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Array Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_TYPE_FEATURE_COUNT = TYPE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>As String</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_TYPE___AS_STRING = TYPE_OPERATION_COUNT + 0;

	/**
	 * The number of operations of the '<em>Array Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_TYPE_OPERATION_COUNT = TYPE_OPERATION_COUNT + 1;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.StatementImpl <em>Statement</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.StatementImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getStatement()
	 * @generated
	 */
	int STATEMENT = 12;

	/**
	 * The number of structural features of the '<em>Statement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STATEMENT_FEATURE_COUNT = 0;

	/**
	 * The number of operations of the '<em>Statement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STATEMENT_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.CompositeStatementImpl <em>Composite Statement</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.CompositeStatementImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getCompositeStatement()
	 * @generated
	 */
	int COMPOSITE_STATEMENT = 68;

	/**
	 * The number of structural features of the '<em>Composite Statement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_STATEMENT_FEATURE_COUNT = STATEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Composite Statement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_STATEMENT_OPERATION_COUNT = STATEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.BlockImpl <em>Block</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.BlockImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getBlock()
	 * @generated
	 */
	int BLOCK = 13;

	/**
	 * The feature id for the '<em><b>Statements</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BLOCK__STATEMENTS = COMPOSITE_STATEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Midconditions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BLOCK__MIDCONDITIONS = COMPOSITE_STATEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Block</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BLOCK_FEATURE_COUNT = COMPOSITE_STATEMENT_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Block</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BLOCK_OPERATION_COUNT = COMPOSITE_STATEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.AssertionImpl <em>Assertion</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.AssertionImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getAssertion()
	 * @generated
	 */
	int ASSERTION = 14;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSERTION__NAME = 0;

	/**
	 * The feature id for the '<em><b>Formula</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSERTION__FORMULA = 1;

	/**
	 * The number of structural features of the '<em>Assertion</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSERTION_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Assertion</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSERTION_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.SimpleStatementImpl <em>Simple Statement</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.SimpleStatementImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getSimpleStatement()
	 * @generated
	 */
	int SIMPLE_STATEMENT = 60;

	/**
	 * The number of structural features of the '<em>Simple Statement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_STATEMENT_FEATURE_COUNT = STATEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Simple Statement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_STATEMENT_OPERATION_COUNT = STATEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.SkipImpl <em>Skip</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.SkipImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getSkip()
	 * @generated
	 */
	int SKIP = 15;

	/**
	 * The number of structural features of the '<em>Skip</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SKIP_FEATURE_COUNT = SIMPLE_STATEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Skip</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SKIP_OPERATION_COUNT = SIMPLE_STATEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.AssignmentImpl <em>Assignment</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.AssignmentImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getAssignment()
	 * @generated
	 */
	int ASSIGNMENT = 16;

	/**
	 * The feature id for the '<em><b>Target</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSIGNMENT__TARGET = SIMPLE_STATEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Value</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSIGNMENT__VALUE = SIMPLE_STATEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Assignment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSIGNMENT_FEATURE_COUNT = SIMPLE_STATEMENT_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Assignment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSIGNMENT_OPERATION_COUNT = SIMPLE_STATEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.LValueImpl <em>LValue</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.LValueImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getLValue()
	 * @generated
	 */
	int LVALUE = 17;

	/**
	 * The feature id for the '<em><b>Variable</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LVALUE__VARIABLE = 0;

	/**
	 * The feature id for the '<em><b>Array Ref</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LVALUE__ARRAY_REF = 1;

	/**
	 * The feature id for the '<em><b>Path</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LVALUE__PATH = 2;

	/**
	 * The number of structural features of the '<em>LValue</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LVALUE_FEATURE_COUNT = 3;

	/**
	 * The number of operations of the '<em>LValue</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LVALUE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.CondImpl <em>Cond</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.CondImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getCond()
	 * @generated
	 */
	int COND = 18;

	/**
	 * The feature id for the '<em><b>Condition</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COND__CONDITION = COMPOSITE_STATEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>If True</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COND__IF_TRUE = COMPOSITE_STATEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>If False</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COND__IF_FALSE = COMPOSITE_STATEMENT_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Cond</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COND_FEATURE_COUNT = COMPOSITE_STATEMENT_FEATURE_COUNT + 3;

	/**
	 * The number of operations of the '<em>Cond</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COND_OPERATION_COUNT = COMPOSITE_STATEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.LoopImpl <em>Loop</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.LoopImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getLoop()
	 * @generated
	 */
	int LOOP = 19;

	/**
	 * The feature id for the '<em><b>Condition</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP__CONDITION = COMPOSITE_STATEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Invariants</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP__INVARIANTS = COMPOSITE_STATEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Body</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP__BODY = COMPOSITE_STATEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Counter</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP__COUNTER = COMPOSITE_STATEMENT_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Loop</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_FEATURE_COUNT = COMPOSITE_STATEMENT_FEATURE_COUNT + 4;

	/**
	 * The number of operations of the '<em>Loop</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_OPERATION_COUNT = COMPOSITE_STATEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.LoopInvariantImpl <em>Loop Invariant</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.LoopInvariantImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getLoopInvariant()
	 * @generated
	 */
	int LOOP_INVARIANT = 20;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_INVARIANT__NAME = 0;

	/**
	 * The feature id for the '<em><b>Formula</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_INVARIANT__FORMULA = 1;

	/**
	 * The number of structural features of the '<em>Loop Invariant</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_INVARIANT_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Loop Invariant</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_INVARIANT_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.ExpressionImpl <em>Expression</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.ExpressionImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getExpression()
	 * @generated
	 */
	int EXPRESSION = 21;

	/**
	 * The number of structural features of the '<em>Expression</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_FEATURE_COUNT = 0;

	/**
	 * The number of operations of the '<em>Expression</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.QuantifiedVarImpl <em>Quantified Var</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.QuantifiedVarImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getQuantifiedVar()
	 * @generated
	 */
	int QUANTIFIED_VAR = 22;

	/**
	 * The feature id for the '<em><b>Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int QUANTIFIED_VAR__TYPE = DECLARED_VARIABLE__TYPE;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int QUANTIFIED_VAR__NAME = DECLARED_VARIABLE__NAME;

	/**
	 * The number of structural features of the '<em>Quantified Var</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int QUANTIFIED_VAR_FEATURE_COUNT = DECLARED_VARIABLE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Get Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int QUANTIFIED_VAR___GET_TYPE = DECLARED_VARIABLE___GET_TYPE;

	/**
	 * The operation id for the '<em>Get Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int QUANTIFIED_VAR___GET_NAME = DECLARED_VARIABLE___GET_NAME;

	/**
	 * The number of operations of the '<em>Quantified Var</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int QUANTIFIED_VAR_OPERATION_COUNT = DECLARED_VARIABLE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.ActualArgsImpl <em>Actual Args</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.ActualArgsImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getActualArgs()
	 * @generated
	 */
	int ACTUAL_ARGS = 23;

	/**
	 * The feature id for the '<em><b>Arguments</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTUAL_ARGS__ARGUMENTS = 0;

	/**
	 * The number of structural features of the '<em>Actual Args</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTUAL_ARGS_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Actual Args</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTUAL_ARGS_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.IntLiteralImpl <em>Int Literal</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.IntLiteralImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getIntLiteral()
	 * @generated
	 */
	int INT_LITERAL = 24;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INT_LITERAL__VALUE = EXPRESSION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Int Literal</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INT_LITERAL_FEATURE_COUNT = EXPRESSION_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Int Literal</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INT_LITERAL_OPERATION_COUNT = EXPRESSION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.BoolLiteralImpl <em>Bool Literal</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.BoolLiteralImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getBoolLiteral()
	 * @generated
	 */
	int BOOL_LITERAL = 26;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOL_LITERAL__VALUE = EXPRESSION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Bool Literal</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOL_LITERAL_FEATURE_COUNT = EXPRESSION_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Bool Literal</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOL_LITERAL_OPERATION_COUNT = EXPRESSION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.BinaryOpImpl <em>Binary Op</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.BinaryOpImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getBinaryOp()
	 * @generated
	 */
	int BINARY_OP = 27;

	/**
	 * The feature id for the '<em><b>Left</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_OP__LEFT = EXPRESSION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Right</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_OP__RIGHT = EXPRESSION_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Binary Op</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_OP_FEATURE_COUNT = EXPRESSION_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Binary Op</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_OP_OPERATION_COUNT = EXPRESSION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.BinaryArithOpImpl <em>Binary Arith Op</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.BinaryArithOpImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getBinaryArithOp()
	 * @generated
	 */
	int BINARY_ARITH_OP = 28;

	/**
	 * The feature id for the '<em><b>Left</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_ARITH_OP__LEFT = BINARY_OP__LEFT;

	/**
	 * The feature id for the '<em><b>Right</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_ARITH_OP__RIGHT = BINARY_OP__RIGHT;

	/**
	 * The number of structural features of the '<em>Binary Arith Op</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_ARITH_OP_FEATURE_COUNT = BINARY_OP_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Binary Arith Op</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_ARITH_OP_OPERATION_COUNT = BINARY_OP_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.BinaryBoolOpImpl <em>Binary Bool Op</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.BinaryBoolOpImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getBinaryBoolOp()
	 * @generated
	 */
	int BINARY_BOOL_OP = 29;

	/**
	 * The feature id for the '<em><b>Left</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_BOOL_OP__LEFT = BINARY_OP__LEFT;

	/**
	 * The feature id for the '<em><b>Right</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_BOOL_OP__RIGHT = BINARY_OP__RIGHT;

	/**
	 * The number of structural features of the '<em>Binary Bool Op</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_BOOL_OP_FEATURE_COUNT = BINARY_OP_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Binary Bool Op</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_BOOL_OP_OPERATION_COUNT = BINARY_OP_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.UnaryOpImpl <em>Unary Op</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.UnaryOpImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getUnaryOp()
	 * @generated
	 */
	int UNARY_OP = 30;

	/**
	 * The feature id for the '<em><b>Arg</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_OP__ARG = EXPRESSION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Unary Op</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_OP_FEATURE_COUNT = EXPRESSION_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Unary Op</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_OP_OPERATION_COUNT = EXPRESSION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.UnaryArithOpImpl <em>Unary Arith Op</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.UnaryArithOpImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getUnaryArithOp()
	 * @generated
	 */
	int UNARY_ARITH_OP = 31;

	/**
	 * The feature id for the '<em><b>Arg</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_ARITH_OP__ARG = UNARY_OP__ARG;

	/**
	 * The number of structural features of the '<em>Unary Arith Op</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_ARITH_OP_FEATURE_COUNT = UNARY_OP_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Unary Arith Op</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_ARITH_OP_OPERATION_COUNT = UNARY_OP_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.UnaryBoolOpImpl <em>Unary Bool Op</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.UnaryBoolOpImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getUnaryBoolOp()
	 * @generated
	 */
	int UNARY_BOOL_OP = 32;

	/**
	 * The feature id for the '<em><b>Arg</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_BOOL_OP__ARG = UNARY_OP__ARG;

	/**
	 * The number of structural features of the '<em>Unary Bool Op</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_BOOL_OP_FEATURE_COUNT = UNARY_OP_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Unary Bool Op</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_BOOL_OP_OPERATION_COUNT = UNARY_OP_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.ComparisonOpImpl <em>Comparison Op</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.ComparisonOpImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getComparisonOp()
	 * @generated
	 */
	int COMPARISON_OP = 33;

	/**
	 * The feature id for the '<em><b>Left</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPARISON_OP__LEFT = BINARY_OP__LEFT;

	/**
	 * The feature id for the '<em><b>Right</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPARISON_OP__RIGHT = BINARY_OP__RIGHT;

	/**
	 * The number of structural features of the '<em>Comparison Op</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPARISON_OP_FEATURE_COUNT = BINARY_OP_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Comparison Op</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPARISON_OP_OPERATION_COUNT = BINARY_OP_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.EquivalenceImpl <em>Equivalence</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.EquivalenceImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getEquivalence()
	 * @generated
	 */
	int EQUIVALENCE = 34;

	/**
	 * The feature id for the '<em><b>Left</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIVALENCE__LEFT = BINARY_BOOL_OP__LEFT;

	/**
	 * The feature id for the '<em><b>Right</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIVALENCE__RIGHT = BINARY_BOOL_OP__RIGHT;

	/**
	 * The number of structural features of the '<em>Equivalence</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIVALENCE_FEATURE_COUNT = BINARY_BOOL_OP_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Equivalence</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIVALENCE_OPERATION_COUNT = BINARY_BOOL_OP_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.ImplicationImpl <em>Implication</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.ImplicationImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getImplication()
	 * @generated
	 */
	int IMPLICATION = 35;

	/**
	 * The feature id for the '<em><b>Left</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IMPLICATION__LEFT = BINARY_BOOL_OP__LEFT;

	/**
	 * The feature id for the '<em><b>Right</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IMPLICATION__RIGHT = BINARY_BOOL_OP__RIGHT;

	/**
	 * The number of structural features of the '<em>Implication</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IMPLICATION_FEATURE_COUNT = BINARY_BOOL_OP_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Implication</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IMPLICATION_OPERATION_COUNT = BINARY_BOOL_OP_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.QuantifierImpl <em>Quantifier</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.QuantifierImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getQuantifier()
	 * @generated
	 */
	int QUANTIFIER = 63;

	/**
	 * The feature id for the '<em><b>Arg</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int QUANTIFIER__ARG = UNARY_BOOL_OP__ARG;

	/**
	 * The feature id for the '<em><b>Vars</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int QUANTIFIER__VARS = UNARY_BOOL_OP_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Patterns</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int QUANTIFIER__PATTERNS = UNARY_BOOL_OP_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Quantifier</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int QUANTIFIER_FEATURE_COUNT = UNARY_BOOL_OP_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Quantifier</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int QUANTIFIER_OPERATION_COUNT = UNARY_BOOL_OP_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.ForallImpl <em>Forall</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.ForallImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getForall()
	 * @generated
	 */
	int FORALL = 36;

	/**
	 * The feature id for the '<em><b>Arg</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORALL__ARG = QUANTIFIER__ARG;

	/**
	 * The feature id for the '<em><b>Vars</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORALL__VARS = QUANTIFIER__VARS;

	/**
	 * The feature id for the '<em><b>Patterns</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORALL__PATTERNS = QUANTIFIER__PATTERNS;

	/**
	 * The number of structural features of the '<em>Forall</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORALL_FEATURE_COUNT = QUANTIFIER_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Forall</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORALL_OPERATION_COUNT = QUANTIFIER_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.ExistsImpl <em>Exists</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.ExistsImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getExists()
	 * @generated
	 */
	int EXISTS = 37;

	/**
	 * The feature id for the '<em><b>Arg</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXISTS__ARG = QUANTIFIER__ARG;

	/**
	 * The feature id for the '<em><b>Vars</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXISTS__VARS = QUANTIFIER__VARS;

	/**
	 * The feature id for the '<em><b>Patterns</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXISTS__PATTERNS = QUANTIFIER__PATTERNS;

	/**
	 * The number of structural features of the '<em>Exists</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXISTS_FEATURE_COUNT = QUANTIFIER_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Exists</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXISTS_OPERATION_COUNT = QUANTIFIER_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.DisjunctionImpl <em>Disjunction</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.DisjunctionImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getDisjunction()
	 * @generated
	 */
	int DISJUNCTION = 38;

	/**
	 * The feature id for the '<em><b>Left</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DISJUNCTION__LEFT = BINARY_BOOL_OP__LEFT;

	/**
	 * The feature id for the '<em><b>Right</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DISJUNCTION__RIGHT = BINARY_BOOL_OP__RIGHT;

	/**
	 * The number of structural features of the '<em>Disjunction</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DISJUNCTION_FEATURE_COUNT = BINARY_BOOL_OP_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Disjunction</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DISJUNCTION_OPERATION_COUNT = BINARY_BOOL_OP_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.ConjunctionImpl <em>Conjunction</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.ConjunctionImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getConjunction()
	 * @generated
	 */
	int CONJUNCTION = 39;

	/**
	 * The feature id for the '<em><b>Left</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONJUNCTION__LEFT = BINARY_BOOL_OP__LEFT;

	/**
	 * The feature id for the '<em><b>Right</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONJUNCTION__RIGHT = BINARY_BOOL_OP__RIGHT;

	/**
	 * The number of structural features of the '<em>Conjunction</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONJUNCTION_FEATURE_COUNT = BINARY_BOOL_OP_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Conjunction</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONJUNCTION_OPERATION_COUNT = BINARY_BOOL_OP_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.NegationImpl <em>Negation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.NegationImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getNegation()
	 * @generated
	 */
	int NEGATION = 40;

	/**
	 * The feature id for the '<em><b>Arg</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEGATION__ARG = UNARY_BOOL_OP__ARG;

	/**
	 * The number of structural features of the '<em>Negation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEGATION_FEATURE_COUNT = UNARY_BOOL_OP_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Negation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEGATION_OPERATION_COUNT = UNARY_BOOL_OP_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.EqImpl <em>Eq</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.EqImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getEq()
	 * @generated
	 */
	int EQ = 41;

	/**
	 * The feature id for the '<em><b>Left</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ__LEFT = COMPARISON_OP__LEFT;

	/**
	 * The feature id for the '<em><b>Right</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ__RIGHT = COMPARISON_OP__RIGHT;

	/**
	 * The number of structural features of the '<em>Eq</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_FEATURE_COUNT = COMPARISON_OP_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Eq</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQ_OPERATION_COUNT = COMPARISON_OP_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.NeqImpl <em>Neq</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.NeqImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getNeq()
	 * @generated
	 */
	int NEQ = 42;

	/**
	 * The feature id for the '<em><b>Left</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEQ__LEFT = COMPARISON_OP__LEFT;

	/**
	 * The feature id for the '<em><b>Right</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEQ__RIGHT = COMPARISON_OP__RIGHT;

	/**
	 * The number of structural features of the '<em>Neq</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEQ_FEATURE_COUNT = COMPARISON_OP_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Neq</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEQ_OPERATION_COUNT = COMPARISON_OP_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.LtImpl <em>Lt</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.LtImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getLt()
	 * @generated
	 */
	int LT = 43;

	/**
	 * The feature id for the '<em><b>Left</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LT__LEFT = COMPARISON_OP__LEFT;

	/**
	 * The feature id for the '<em><b>Right</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LT__RIGHT = COMPARISON_OP__RIGHT;

	/**
	 * The number of structural features of the '<em>Lt</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LT_FEATURE_COUNT = COMPARISON_OP_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Lt</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LT_OPERATION_COUNT = COMPARISON_OP_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.LeImpl <em>Le</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.LeImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getLe()
	 * @generated
	 */
	int LE = 44;

	/**
	 * The feature id for the '<em><b>Left</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LE__LEFT = COMPARISON_OP__LEFT;

	/**
	 * The feature id for the '<em><b>Right</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LE__RIGHT = COMPARISON_OP__RIGHT;

	/**
	 * The number of structural features of the '<em>Le</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LE_FEATURE_COUNT = COMPARISON_OP_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Le</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LE_OPERATION_COUNT = COMPARISON_OP_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.GtImpl <em>Gt</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.GtImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getGt()
	 * @generated
	 */
	int GT = 45;

	/**
	 * The feature id for the '<em><b>Left</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT__LEFT = COMPARISON_OP__LEFT;

	/**
	 * The feature id for the '<em><b>Right</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT__RIGHT = COMPARISON_OP__RIGHT;

	/**
	 * The number of structural features of the '<em>Gt</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_FEATURE_COUNT = COMPARISON_OP_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Gt</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_OPERATION_COUNT = COMPARISON_OP_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.GeImpl <em>Ge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.GeImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getGe()
	 * @generated
	 */
	int GE = 46;

	/**
	 * The feature id for the '<em><b>Left</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GE__LEFT = COMPARISON_OP__LEFT;

	/**
	 * The feature id for the '<em><b>Right</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GE__RIGHT = COMPARISON_OP__RIGHT;

	/**
	 * The number of structural features of the '<em>Ge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GE_FEATURE_COUNT = COMPARISON_OP_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Ge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GE_OPERATION_COUNT = COMPARISON_OP_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.AddImpl <em>Add</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.AddImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getAdd()
	 * @generated
	 */
	int ADD = 47;

	/**
	 * The feature id for the '<em><b>Left</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADD__LEFT = BINARY_ARITH_OP__LEFT;

	/**
	 * The feature id for the '<em><b>Right</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADD__RIGHT = BINARY_ARITH_OP__RIGHT;

	/**
	 * The number of structural features of the '<em>Add</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADD_FEATURE_COUNT = BINARY_ARITH_OP_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Add</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADD_OPERATION_COUNT = BINARY_ARITH_OP_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.SubImpl <em>Sub</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.SubImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getSub()
	 * @generated
	 */
	int SUB = 48;

	/**
	 * The feature id for the '<em><b>Left</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB__LEFT = BINARY_ARITH_OP__LEFT;

	/**
	 * The feature id for the '<em><b>Right</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB__RIGHT = BINARY_ARITH_OP__RIGHT;

	/**
	 * The number of structural features of the '<em>Sub</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_FEATURE_COUNT = BINARY_ARITH_OP_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Sub</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUB_OPERATION_COUNT = BINARY_ARITH_OP_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.MultImpl <em>Mult</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.MultImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getMult()
	 * @generated
	 */
	int MULT = 49;

	/**
	 * The feature id for the '<em><b>Left</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MULT__LEFT = BINARY_ARITH_OP__LEFT;

	/**
	 * The feature id for the '<em><b>Right</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MULT__RIGHT = BINARY_ARITH_OP__RIGHT;

	/**
	 * The number of structural features of the '<em>Mult</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MULT_FEATURE_COUNT = BINARY_ARITH_OP_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Mult</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MULT_OPERATION_COUNT = BINARY_ARITH_OP_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.DivImpl <em>Div</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.DivImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getDiv()
	 * @generated
	 */
	int DIV = 50;

	/**
	 * The feature id for the '<em><b>Left</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIV__LEFT = BINARY_ARITH_OP__LEFT;

	/**
	 * The feature id for the '<em><b>Right</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIV__RIGHT = BINARY_ARITH_OP__RIGHT;

	/**
	 * The number of structural features of the '<em>Div</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIV_FEATURE_COUNT = BINARY_ARITH_OP_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Div</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIV_OPERATION_COUNT = BINARY_ARITH_OP_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.ModImpl <em>Mod</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.ModImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getMod()
	 * @generated
	 */
	int MOD = 51;

	/**
	 * The feature id for the '<em><b>Left</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOD__LEFT = BINARY_ARITH_OP__LEFT;

	/**
	 * The feature id for the '<em><b>Right</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOD__RIGHT = BINARY_ARITH_OP__RIGHT;

	/**
	 * The number of structural features of the '<em>Mod</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOD_FEATURE_COUNT = BINARY_ARITH_OP_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Mod</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOD_OPERATION_COUNT = BINARY_ARITH_OP_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.UminusImpl <em>Uminus</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.UminusImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getUminus()
	 * @generated
	 */
	int UMINUS = 52;

	/**
	 * The feature id for the '<em><b>Arg</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UMINUS__ARG = UNARY_ARITH_OP__ARG;

	/**
	 * The number of structural features of the '<em>Uminus</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UMINUS_FEATURE_COUNT = UNARY_ARITH_OP_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Uminus</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UMINUS_OPERATION_COUNT = UNARY_ARITH_OP_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.VarImpl <em>Var</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.VarImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getVar()
	 * @generated
	 */
	int VAR = 53;

	/**
	 * The feature id for the '<em><b>Symbol</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAR__SYMBOL = EXPRESSION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Var</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAR_FEATURE_COUNT = EXPRESSION_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Get Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAR___GET_NAME = EXPRESSION_OPERATION_COUNT + 0;

	/**
	 * The operation id for the '<em>Get Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAR___GET_TYPE = EXPRESSION_OPERATION_COUNT + 1;

	/**
	 * The number of operations of the '<em>Var</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAR_OPERATION_COUNT = EXPRESSION_OPERATION_COUNT + 2;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.CallImpl <em>Call</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.CallImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getCall()
	 * @generated
	 */
	int CALL = 54;

	/**
	 * The feature id for the '<em><b>Function</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL__FUNCTION = EXPRESSION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Args</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL__ARGS = EXPRESSION_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Call</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_FEATURE_COUNT = EXPRESSION_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Call</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_OPERATION_COUNT = EXPRESSION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.ArrayAccessImpl <em>Array Access</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.ArrayAccessImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getArrayAccess()
	 * @generated
	 */
	int ARRAY_ACCESS = 55;

	/**
	 * The feature id for the '<em><b>Array</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_ACCESS__ARRAY = EXPRESSION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Path</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_ACCESS__PATH = EXPRESSION_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Array Access</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_ACCESS_FEATURE_COUNT = EXPRESSION_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Array Access</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_ACCESS_OPERATION_COUNT = EXPRESSION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.Assignable <em>Assignable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.Assignable
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getAssignable()
	 * @generated
	 */
	int ASSIGNABLE = 57;

	/**
	 * The number of structural features of the '<em>Assignable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSIGNABLE_FEATURE_COUNT = 0;

	/**
	 * The operation id for the '<em>Get Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSIGNABLE___GET_TYPE = 0;

	/**
	 * The operation id for the '<em>Get Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSIGNABLE___GET_NAME = 1;

	/**
	 * The number of operations of the '<em>Assignable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSIGNABLE_OPERATION_COUNT = 2;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.ResultVarImpl <em>Result Var</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.ResultVarImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getResultVar()
	 * @generated
	 */
	int RESULT_VAR = 58;

	/**
	 * The feature id for the '<em><b>Function</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESULT_VAR__FUNCTION = ASSIGNABLE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Result Var</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESULT_VAR_FEATURE_COUNT = ASSIGNABLE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Get Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESULT_VAR___GET_NAME = ASSIGNABLE_OPERATION_COUNT + 2;

	/**
	 * The operation id for the '<em>Get Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESULT_VAR___GET_TYPE = ASSIGNABLE_OPERATION_COUNT + 3;

	/**
	 * The number of operations of the '<em>Result Var</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESULT_VAR_OPERATION_COUNT = ASSIGNABLE_OPERATION_COUNT + 4;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.PowerImpl <em>Power</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.PowerImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getPower()
	 * @generated
	 */
	int POWER = 61;

	/**
	 * The feature id for the '<em><b>Left</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER__LEFT = BINARY_ARITH_OP__LEFT;

	/**
	 * The feature id for the '<em><b>Right</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER__RIGHT = BINARY_ARITH_OP__RIGHT;

	/**
	 * The number of structural features of the '<em>Power</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_FEATURE_COUNT = BINARY_ARITH_OP_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Power</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_OPERATION_COUNT = BINARY_ARITH_OP_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.AxiomImpl <em>Axiom</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.AxiomImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getAxiom()
	 * @generated
	 */
	int AXIOM = 62;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AXIOM__NAME = 0;

	/**
	 * The feature id for the '<em><b>Formula</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AXIOM__FORMULA = 1;

	/**
	 * The number of structural features of the '<em>Axiom</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AXIOM_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Axiom</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AXIOM_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.ExistsVarImpl <em>Exists Var</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.ExistsVarImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getExistsVar()
	 * @generated
	 */
	int EXISTS_VAR = 64;

	/**
	 * The feature id for the '<em><b>Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXISTS_VAR__TYPE = QUANTIFIED_VAR__TYPE;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXISTS_VAR__NAME = QUANTIFIED_VAR__NAME;

	/**
	 * The number of structural features of the '<em>Exists Var</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXISTS_VAR_FEATURE_COUNT = QUANTIFIED_VAR_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Get Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXISTS_VAR___GET_TYPE = QUANTIFIED_VAR___GET_TYPE;

	/**
	 * The operation id for the '<em>Get Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXISTS_VAR___GET_NAME = QUANTIFIED_VAR___GET_NAME;

	/**
	 * The number of operations of the '<em>Exists Var</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXISTS_VAR_OPERATION_COUNT = QUANTIFIED_VAR_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.ForallVarImpl <em>Forall Var</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.ForallVarImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getForallVar()
	 * @generated
	 */
	int FORALL_VAR = 65;

	/**
	 * The feature id for the '<em><b>Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORALL_VAR__TYPE = QUANTIFIED_VAR__TYPE;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORALL_VAR__NAME = QUANTIFIED_VAR__NAME;

	/**
	 * The number of structural features of the '<em>Forall Var</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORALL_VAR_FEATURE_COUNT = QUANTIFIED_VAR_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Get Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORALL_VAR___GET_TYPE = QUANTIFIED_VAR___GET_TYPE;

	/**
	 * The operation id for the '<em>Get Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORALL_VAR___GET_NAME = QUANTIFIED_VAR___GET_NAME;

	/**
	 * The number of operations of the '<em>Forall Var</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORALL_VAR_OPERATION_COUNT = QUANTIFIED_VAR_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.AssertionListImpl <em>Assertion List</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.AssertionListImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getAssertionList()
	 * @generated
	 */
	int ASSERTION_LIST = 66;

	/**
	 * The feature id for the '<em><b>Assertions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSERTION_LIST__ASSERTIONS = 0;

	/**
	 * The number of structural features of the '<em>Assertion List</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSERTION_LIST_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Assertion List</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSERTION_LIST_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.HoareTripleImpl <em>Hoare Triple</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.HoareTripleImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getHoareTriple()
	 * @generated
	 */
	int HOARE_TRIPLE = 67;

	/**
	 * The feature id for the '<em><b>Precondition</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HOARE_TRIPLE__PRECONDITION = 0;

	/**
	 * The feature id for the '<em><b>Statement</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HOARE_TRIPLE__STATEMENT = 1;

	/**
	 * The feature id for the '<em><b>Postcondition</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HOARE_TRIPLE__POSTCONDITION = 2;

	/**
	 * The number of structural features of the '<em>Hoare Triple</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HOARE_TRIPLE_FEATURE_COUNT = 3;

	/**
	 * The number of operations of the '<em>Hoare Triple</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HOARE_TRIPLE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.CounterVariableImpl <em>Counter Variable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.CounterVariableImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getCounterVariable()
	 * @generated
	 */
	int COUNTER_VARIABLE = 69;

	/**
	 * The feature id for the '<em><b>Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COUNTER_VARIABLE__TYPE = DECLARED_VARIABLE__TYPE;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COUNTER_VARIABLE__NAME = DECLARED_VARIABLE__NAME;

	/**
	 * The number of structural features of the '<em>Counter Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COUNTER_VARIABLE_FEATURE_COUNT = DECLARED_VARIABLE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Get Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COUNTER_VARIABLE___GET_TYPE = DECLARED_VARIABLE___GET_TYPE;

	/**
	 * The operation id for the '<em>Get Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COUNTER_VARIABLE___GET_NAME = DECLARED_VARIABLE___GET_NAME;

	/**
	 * The number of operations of the '<em>Counter Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COUNTER_VARIABLE_OPERATION_COUNT = DECLARED_VARIABLE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.impl.LoopCounterImpl <em>Loop Counter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.impl.LoopCounterImpl
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getLoopCounter()
	 * @generated
	 */
	int LOOP_COUNTER = 70;

	/**
	 * The feature id for the '<em><b>Variable</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_COUNTER__VARIABLE = 0;

	/**
	 * The feature id for the '<em><b>Formula</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_COUNTER__FORMULA = 1;

	/**
	 * The feature id for the '<em><b>New Value</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_COUNTER__NEW_VALUE = 2;

	/**
	 * The number of structural features of the '<em>Loop Counter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_COUNTER_FEATURE_COUNT = 3;

	/**
	 * The number of operations of the '<em>Loop Counter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_COUNTER_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.PrimitiveType <em>Primitive Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.PrimitiveType
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getPrimitiveType()
	 * @generated
	 */
	int PRIMITIVE_TYPE = 71;

	/**
	 * The meta object id for the '{@link net.afyre.haha.demo.haha.Bool <em>Bool</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.afyre.haha.demo.haha.Bool
	 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getBool()
	 * @generated
	 */
	int BOOL = 72;


	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Program <em>Program</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Program</em>'.
	 * @see net.afyre.haha.demo.haha.Program
	 * @generated
	 */
	EClass getProgram();

	/**
	 * Returns the meta object for the containment reference list '{@link net.afyre.haha.demo.haha.Program#getPredicates <em>Predicates</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Predicates</em>'.
	 * @see net.afyre.haha.demo.haha.Program#getPredicates()
	 * @see #getProgram()
	 * @generated
	 */
	EReference getProgram_Predicates();

	/**
	 * Returns the meta object for the containment reference list '{@link net.afyre.haha.demo.haha.Program#getFunctions <em>Functions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Functions</em>'.
	 * @see net.afyre.haha.demo.haha.Program#getFunctions()
	 * @see #getProgram()
	 * @generated
	 */
	EReference getProgram_Functions();

	/**
	 * Returns the meta object for the containment reference list '{@link net.afyre.haha.demo.haha.Program#getAxioms <em>Axioms</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Axioms</em>'.
	 * @see net.afyre.haha.demo.haha.Program#getAxioms()
	 * @see #getProgram()
	 * @generated
	 */
	EReference getProgram_Axioms();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Predicate <em>Predicate</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Predicate</em>'.
	 * @see net.afyre.haha.demo.haha.Predicate
	 * @generated
	 */
	EClass getPredicate();

	/**
	 * Returns the meta object for the containment reference '{@link net.afyre.haha.demo.haha.Predicate#getFormula <em>Formula</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Formula</em>'.
	 * @see net.afyre.haha.demo.haha.Predicate#getFormula()
	 * @see #getPredicate()
	 * @generated
	 */
	EReference getPredicate_Formula();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Function <em>Function</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Function</em>'.
	 * @see net.afyre.haha.demo.haha.Function
	 * @generated
	 */
	EClass getFunction();

	/**
	 * Returns the meta object for the containment reference '{@link net.afyre.haha.demo.haha.Function#getResultType <em>Result Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Result Type</em>'.
	 * @see net.afyre.haha.demo.haha.Function#getResultType()
	 * @see #getFunction()
	 * @generated
	 */
	EReference getFunction_ResultType();

	/**
	 * Returns the meta object for the attribute list '{@link net.afyre.haha.demo.haha.Function#getDocs <em>Docs</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Docs</em>'.
	 * @see net.afyre.haha.demo.haha.Function#getDocs()
	 * @see #getFunction()
	 * @generated
	 */
	EAttribute getFunction_Docs();

	/**
	 * Returns the meta object for the containment reference list '{@link net.afyre.haha.demo.haha.Function#getPreconditions <em>Preconditions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Preconditions</em>'.
	 * @see net.afyre.haha.demo.haha.Function#getPreconditions()
	 * @see #getFunction()
	 * @generated
	 */
	EReference getFunction_Preconditions();

	/**
	 * Returns the meta object for the containment reference list '{@link net.afyre.haha.demo.haha.Function#getPostconditions <em>Postconditions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Postconditions</em>'.
	 * @see net.afyre.haha.demo.haha.Function#getPostconditions()
	 * @see #getFunction()
	 * @generated
	 */
	EReference getFunction_Postconditions();

	/**
	 * Returns the meta object for the containment reference list '{@link net.afyre.haha.demo.haha.Function#getLocals <em>Locals</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Locals</em>'.
	 * @see net.afyre.haha.demo.haha.Function#getLocals()
	 * @see #getFunction()
	 * @generated
	 */
	EReference getFunction_Locals();

	/**
	 * Returns the meta object for the containment reference '{@link net.afyre.haha.demo.haha.Function#getBody <em>Body</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Body</em>'.
	 * @see net.afyre.haha.demo.haha.Function#getBody()
	 * @see #getFunction()
	 * @generated
	 */
	EReference getFunction_Body();

	/**
	 * Returns the meta object for the containment reference '{@link net.afyre.haha.demo.haha.Function#getResultVar <em>Result Var</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Result Var</em>'.
	 * @see net.afyre.haha.demo.haha.Function#getResultVar()
	 * @see #getFunction()
	 * @generated
	 */
	EReference getFunction_ResultVar();

	/**
	 * Returns the meta object for the '{@link net.afyre.haha.demo.haha.Function#resultVar() <em>Result Var</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Result Var</em>' operation.
	 * @see net.afyre.haha.demo.haha.Function#resultVar()
	 * @generated
	 */
	EOperation getFunction__ResultVar();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.ArgumentList <em>Argument List</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Argument List</em>'.
	 * @see net.afyre.haha.demo.haha.ArgumentList
	 * @generated
	 */
	EClass getArgumentList();

	/**
	 * Returns the meta object for the containment reference list '{@link net.afyre.haha.demo.haha.ArgumentList#getArguments <em>Arguments</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Arguments</em>'.
	 * @see net.afyre.haha.demo.haha.ArgumentList#getArguments()
	 * @see #getArgumentList()
	 * @generated
	 */
	EReference getArgumentList_Arguments();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Argument <em>Argument</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Argument</em>'.
	 * @see net.afyre.haha.demo.haha.Argument
	 * @generated
	 */
	EClass getArgument();

	/**
	 * Returns the meta object for the attribute '{@link net.afyre.haha.demo.haha.Argument#getDoc <em>Doc</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Doc</em>'.
	 * @see net.afyre.haha.demo.haha.Argument#getDoc()
	 * @see #getArgument()
	 * @generated
	 */
	EAttribute getArgument_Doc();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Precondition <em>Precondition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Precondition</em>'.
	 * @see net.afyre.haha.demo.haha.Precondition
	 * @generated
	 */
	EClass getPrecondition();

	/**
	 * Returns the meta object for the attribute '{@link net.afyre.haha.demo.haha.Precondition#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see net.afyre.haha.demo.haha.Precondition#getName()
	 * @see #getPrecondition()
	 * @generated
	 */
	EAttribute getPrecondition_Name();

	/**
	 * Returns the meta object for the containment reference '{@link net.afyre.haha.demo.haha.Precondition#getFormula <em>Formula</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Formula</em>'.
	 * @see net.afyre.haha.demo.haha.Precondition#getFormula()
	 * @see #getPrecondition()
	 * @generated
	 */
	EReference getPrecondition_Formula();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Postcondition <em>Postcondition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Postcondition</em>'.
	 * @see net.afyre.haha.demo.haha.Postcondition
	 * @generated
	 */
	EClass getPostcondition();

	/**
	 * Returns the meta object for the attribute '{@link net.afyre.haha.demo.haha.Postcondition#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see net.afyre.haha.demo.haha.Postcondition#getName()
	 * @see #getPostcondition()
	 * @generated
	 */
	EAttribute getPostcondition_Name();

	/**
	 * Returns the meta object for the containment reference '{@link net.afyre.haha.demo.haha.Postcondition#getFormula <em>Formula</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Formula</em>'.
	 * @see net.afyre.haha.demo.haha.Postcondition#getFormula()
	 * @see #getPostcondition()
	 * @generated
	 */
	EReference getPostcondition_Formula();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Locals <em>Locals</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Locals</em>'.
	 * @see net.afyre.haha.demo.haha.Locals
	 * @generated
	 */
	EClass getLocals();

	/**
	 * Returns the meta object for the containment reference list '{@link net.afyre.haha.demo.haha.Locals#getVariables <em>Variables</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Variables</em>'.
	 * @see net.afyre.haha.demo.haha.Locals#getVariables()
	 * @see #getLocals()
	 * @generated
	 */
	EReference getLocals_Variables();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Local <em>Local</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Local</em>'.
	 * @see net.afyre.haha.demo.haha.Local
	 * @generated
	 */
	EClass getLocal();

	/**
	 * Returns the meta object for the attribute '{@link net.afyre.haha.demo.haha.Local#getDoc <em>Doc</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Doc</em>'.
	 * @see net.afyre.haha.demo.haha.Local#getDoc()
	 * @see #getLocal()
	 * @generated
	 */
	EAttribute getLocal_Doc();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Type <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Type</em>'.
	 * @see net.afyre.haha.demo.haha.Type
	 * @generated
	 */
	EClass getType();

	/**
	 * Returns the meta object for the '{@link net.afyre.haha.demo.haha.Type#asString() <em>As String</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>As String</em>' operation.
	 * @see net.afyre.haha.demo.haha.Type#asString()
	 * @generated
	 */
	EOperation getType__AsString();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.SimpleType <em>Simple Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Simple Type</em>'.
	 * @see net.afyre.haha.demo.haha.SimpleType
	 * @generated
	 */
	EClass getSimpleType();

	/**
	 * Returns the meta object for the attribute '{@link net.afyre.haha.demo.haha.SimpleType#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see net.afyre.haha.demo.haha.SimpleType#getType()
	 * @see #getSimpleType()
	 * @generated
	 */
	EAttribute getSimpleType_Type();

	/**
	 * Returns the meta object for the '{@link net.afyre.haha.demo.haha.SimpleType#asString() <em>As String</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>As String</em>' operation.
	 * @see net.afyre.haha.demo.haha.SimpleType#asString()
	 * @generated
	 */
	EOperation getSimpleType__AsString();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.ArrayType <em>Array Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Array Type</em>'.
	 * @see net.afyre.haha.demo.haha.ArrayType
	 * @generated
	 */
	EClass getArrayType();

	/**
	 * Returns the meta object for the containment reference '{@link net.afyre.haha.demo.haha.ArrayType#getElementType <em>Element Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Element Type</em>'.
	 * @see net.afyre.haha.demo.haha.ArrayType#getElementType()
	 * @see #getArrayType()
	 * @generated
	 */
	EReference getArrayType_ElementType();

	/**
	 * Returns the meta object for the '{@link net.afyre.haha.demo.haha.ArrayType#asString() <em>As String</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>As String</em>' operation.
	 * @see net.afyre.haha.demo.haha.ArrayType#asString()
	 * @generated
	 */
	EOperation getArrayType__AsString();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Statement <em>Statement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Statement</em>'.
	 * @see net.afyre.haha.demo.haha.Statement
	 * @generated
	 */
	EClass getStatement();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Block <em>Block</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Block</em>'.
	 * @see net.afyre.haha.demo.haha.Block
	 * @generated
	 */
	EClass getBlock();

	/**
	 * Returns the meta object for the containment reference list '{@link net.afyre.haha.demo.haha.Block#getStatements <em>Statements</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Statements</em>'.
	 * @see net.afyre.haha.demo.haha.Block#getStatements()
	 * @see #getBlock()
	 * @generated
	 */
	EReference getBlock_Statements();

	/**
	 * Returns the meta object for the containment reference list '{@link net.afyre.haha.demo.haha.Block#getMidconditions <em>Midconditions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Midconditions</em>'.
	 * @see net.afyre.haha.demo.haha.Block#getMidconditions()
	 * @see #getBlock()
	 * @generated
	 */
	EReference getBlock_Midconditions();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Assertion <em>Assertion</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Assertion</em>'.
	 * @see net.afyre.haha.demo.haha.Assertion
	 * @generated
	 */
	EClass getAssertion();

	/**
	 * Returns the meta object for the attribute '{@link net.afyre.haha.demo.haha.Assertion#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see net.afyre.haha.demo.haha.Assertion#getName()
	 * @see #getAssertion()
	 * @generated
	 */
	EAttribute getAssertion_Name();

	/**
	 * Returns the meta object for the containment reference '{@link net.afyre.haha.demo.haha.Assertion#getFormula <em>Formula</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Formula</em>'.
	 * @see net.afyre.haha.demo.haha.Assertion#getFormula()
	 * @see #getAssertion()
	 * @generated
	 */
	EReference getAssertion_Formula();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Skip <em>Skip</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Skip</em>'.
	 * @see net.afyre.haha.demo.haha.Skip
	 * @generated
	 */
	EClass getSkip();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Assignment <em>Assignment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Assignment</em>'.
	 * @see net.afyre.haha.demo.haha.Assignment
	 * @generated
	 */
	EClass getAssignment();

	/**
	 * Returns the meta object for the containment reference '{@link net.afyre.haha.demo.haha.Assignment#getTarget <em>Target</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Target</em>'.
	 * @see net.afyre.haha.demo.haha.Assignment#getTarget()
	 * @see #getAssignment()
	 * @generated
	 */
	EReference getAssignment_Target();

	/**
	 * Returns the meta object for the containment reference '{@link net.afyre.haha.demo.haha.Assignment#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Value</em>'.
	 * @see net.afyre.haha.demo.haha.Assignment#getValue()
	 * @see #getAssignment()
	 * @generated
	 */
	EReference getAssignment_Value();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.LValue <em>LValue</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>LValue</em>'.
	 * @see net.afyre.haha.demo.haha.LValue
	 * @generated
	 */
	EClass getLValue();

	/**
	 * Returns the meta object for the reference '{@link net.afyre.haha.demo.haha.LValue#getVariable <em>Variable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Variable</em>'.
	 * @see net.afyre.haha.demo.haha.LValue#getVariable()
	 * @see #getLValue()
	 * @generated
	 */
	EReference getLValue_Variable();

	/**
	 * Returns the meta object for the attribute '{@link net.afyre.haha.demo.haha.LValue#isArrayRef <em>Array Ref</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Array Ref</em>'.
	 * @see net.afyre.haha.demo.haha.LValue#isArrayRef()
	 * @see #getLValue()
	 * @generated
	 */
	EAttribute getLValue_ArrayRef();

	/**
	 * Returns the meta object for the containment reference list '{@link net.afyre.haha.demo.haha.LValue#getPath <em>Path</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Path</em>'.
	 * @see net.afyre.haha.demo.haha.LValue#getPath()
	 * @see #getLValue()
	 * @generated
	 */
	EReference getLValue_Path();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Cond <em>Cond</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Cond</em>'.
	 * @see net.afyre.haha.demo.haha.Cond
	 * @generated
	 */
	EClass getCond();

	/**
	 * Returns the meta object for the containment reference '{@link net.afyre.haha.demo.haha.Cond#getCondition <em>Condition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Condition</em>'.
	 * @see net.afyre.haha.demo.haha.Cond#getCondition()
	 * @see #getCond()
	 * @generated
	 */
	EReference getCond_Condition();

	/**
	 * Returns the meta object for the containment reference '{@link net.afyre.haha.demo.haha.Cond#getIfTrue <em>If True</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>If True</em>'.
	 * @see net.afyre.haha.demo.haha.Cond#getIfTrue()
	 * @see #getCond()
	 * @generated
	 */
	EReference getCond_IfTrue();

	/**
	 * Returns the meta object for the containment reference '{@link net.afyre.haha.demo.haha.Cond#getIfFalse <em>If False</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>If False</em>'.
	 * @see net.afyre.haha.demo.haha.Cond#getIfFalse()
	 * @see #getCond()
	 * @generated
	 */
	EReference getCond_IfFalse();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Loop <em>Loop</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Loop</em>'.
	 * @see net.afyre.haha.demo.haha.Loop
	 * @generated
	 */
	EClass getLoop();

	/**
	 * Returns the meta object for the containment reference '{@link net.afyre.haha.demo.haha.Loop#getCondition <em>Condition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Condition</em>'.
	 * @see net.afyre.haha.demo.haha.Loop#getCondition()
	 * @see #getLoop()
	 * @generated
	 */
	EReference getLoop_Condition();

	/**
	 * Returns the meta object for the containment reference list '{@link net.afyre.haha.demo.haha.Loop#getInvariants <em>Invariants</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Invariants</em>'.
	 * @see net.afyre.haha.demo.haha.Loop#getInvariants()
	 * @see #getLoop()
	 * @generated
	 */
	EReference getLoop_Invariants();

	/**
	 * Returns the meta object for the containment reference '{@link net.afyre.haha.demo.haha.Loop#getBody <em>Body</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Body</em>'.
	 * @see net.afyre.haha.demo.haha.Loop#getBody()
	 * @see #getLoop()
	 * @generated
	 */
	EReference getLoop_Body();

	/**
	 * Returns the meta object for the containment reference '{@link net.afyre.haha.demo.haha.Loop#getCounter <em>Counter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Counter</em>'.
	 * @see net.afyre.haha.demo.haha.Loop#getCounter()
	 * @see #getLoop()
	 * @generated
	 */
	EReference getLoop_Counter();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.LoopInvariant <em>Loop Invariant</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Loop Invariant</em>'.
	 * @see net.afyre.haha.demo.haha.LoopInvariant
	 * @generated
	 */
	EClass getLoopInvariant();

	/**
	 * Returns the meta object for the attribute '{@link net.afyre.haha.demo.haha.LoopInvariant#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see net.afyre.haha.demo.haha.LoopInvariant#getName()
	 * @see #getLoopInvariant()
	 * @generated
	 */
	EAttribute getLoopInvariant_Name();

	/**
	 * Returns the meta object for the containment reference '{@link net.afyre.haha.demo.haha.LoopInvariant#getFormula <em>Formula</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Formula</em>'.
	 * @see net.afyre.haha.demo.haha.LoopInvariant#getFormula()
	 * @see #getLoopInvariant()
	 * @generated
	 */
	EReference getLoopInvariant_Formula();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Expression <em>Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Expression</em>'.
	 * @see net.afyre.haha.demo.haha.Expression
	 * @generated
	 */
	EClass getExpression();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.QuantifiedVar <em>Quantified Var</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Quantified Var</em>'.
	 * @see net.afyre.haha.demo.haha.QuantifiedVar
	 * @generated
	 */
	EClass getQuantifiedVar();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.ActualArgs <em>Actual Args</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Actual Args</em>'.
	 * @see net.afyre.haha.demo.haha.ActualArgs
	 * @generated
	 */
	EClass getActualArgs();

	/**
	 * Returns the meta object for the containment reference list '{@link net.afyre.haha.demo.haha.ActualArgs#getArguments <em>Arguments</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Arguments</em>'.
	 * @see net.afyre.haha.demo.haha.ActualArgs#getArguments()
	 * @see #getActualArgs()
	 * @generated
	 */
	EReference getActualArgs_Arguments();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.IntLiteral <em>Int Literal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Int Literal</em>'.
	 * @see net.afyre.haha.demo.haha.IntLiteral
	 * @generated
	 */
	EClass getIntLiteral();

	/**
	 * Returns the meta object for the attribute '{@link net.afyre.haha.demo.haha.IntLiteral#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see net.afyre.haha.demo.haha.IntLiteral#getValue()
	 * @see #getIntLiteral()
	 * @generated
	 */
	EAttribute getIntLiteral_Value();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.DeclaredVariable <em>Declared Variable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Declared Variable</em>'.
	 * @see net.afyre.haha.demo.haha.DeclaredVariable
	 * @generated
	 */
	EClass getDeclaredVariable();

	/**
	 * Returns the meta object for the containment reference '{@link net.afyre.haha.demo.haha.DeclaredVariable#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Type</em>'.
	 * @see net.afyre.haha.demo.haha.DeclaredVariable#getType()
	 * @see #getDeclaredVariable()
	 * @generated
	 */
	EReference getDeclaredVariable_Type();

	/**
	 * Returns the meta object for the attribute '{@link net.afyre.haha.demo.haha.DeclaredVariable#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see net.afyre.haha.demo.haha.DeclaredVariable#getName()
	 * @see #getDeclaredVariable()
	 * @generated
	 */
	EAttribute getDeclaredVariable_Name();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.BoolLiteral <em>Bool Literal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Bool Literal</em>'.
	 * @see net.afyre.haha.demo.haha.BoolLiteral
	 * @generated
	 */
	EClass getBoolLiteral();

	/**
	 * Returns the meta object for the attribute '{@link net.afyre.haha.demo.haha.BoolLiteral#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see net.afyre.haha.demo.haha.BoolLiteral#getValue()
	 * @see #getBoolLiteral()
	 * @generated
	 */
	EAttribute getBoolLiteral_Value();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.BinaryOp <em>Binary Op</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Binary Op</em>'.
	 * @see net.afyre.haha.demo.haha.BinaryOp
	 * @generated
	 */
	EClass getBinaryOp();

	/**
	 * Returns the meta object for the containment reference '{@link net.afyre.haha.demo.haha.BinaryOp#getLeft <em>Left</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Left</em>'.
	 * @see net.afyre.haha.demo.haha.BinaryOp#getLeft()
	 * @see #getBinaryOp()
	 * @generated
	 */
	EReference getBinaryOp_Left();

	/**
	 * Returns the meta object for the containment reference '{@link net.afyre.haha.demo.haha.BinaryOp#getRight <em>Right</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Right</em>'.
	 * @see net.afyre.haha.demo.haha.BinaryOp#getRight()
	 * @see #getBinaryOp()
	 * @generated
	 */
	EReference getBinaryOp_Right();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.BinaryArithOp <em>Binary Arith Op</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Binary Arith Op</em>'.
	 * @see net.afyre.haha.demo.haha.BinaryArithOp
	 * @generated
	 */
	EClass getBinaryArithOp();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.BinaryBoolOp <em>Binary Bool Op</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Binary Bool Op</em>'.
	 * @see net.afyre.haha.demo.haha.BinaryBoolOp
	 * @generated
	 */
	EClass getBinaryBoolOp();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.UnaryOp <em>Unary Op</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Unary Op</em>'.
	 * @see net.afyre.haha.demo.haha.UnaryOp
	 * @generated
	 */
	EClass getUnaryOp();

	/**
	 * Returns the meta object for the containment reference '{@link net.afyre.haha.demo.haha.UnaryOp#getArg <em>Arg</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Arg</em>'.
	 * @see net.afyre.haha.demo.haha.UnaryOp#getArg()
	 * @see #getUnaryOp()
	 * @generated
	 */
	EReference getUnaryOp_Arg();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.UnaryArithOp <em>Unary Arith Op</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Unary Arith Op</em>'.
	 * @see net.afyre.haha.demo.haha.UnaryArithOp
	 * @generated
	 */
	EClass getUnaryArithOp();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.UnaryBoolOp <em>Unary Bool Op</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Unary Bool Op</em>'.
	 * @see net.afyre.haha.demo.haha.UnaryBoolOp
	 * @generated
	 */
	EClass getUnaryBoolOp();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.ComparisonOp <em>Comparison Op</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Comparison Op</em>'.
	 * @see net.afyre.haha.demo.haha.ComparisonOp
	 * @generated
	 */
	EClass getComparisonOp();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Equivalence <em>Equivalence</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Equivalence</em>'.
	 * @see net.afyre.haha.demo.haha.Equivalence
	 * @generated
	 */
	EClass getEquivalence();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Implication <em>Implication</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Implication</em>'.
	 * @see net.afyre.haha.demo.haha.Implication
	 * @generated
	 */
	EClass getImplication();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Forall <em>Forall</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Forall</em>'.
	 * @see net.afyre.haha.demo.haha.Forall
	 * @generated
	 */
	EClass getForall();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Exists <em>Exists</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Exists</em>'.
	 * @see net.afyre.haha.demo.haha.Exists
	 * @generated
	 */
	EClass getExists();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Disjunction <em>Disjunction</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Disjunction</em>'.
	 * @see net.afyre.haha.demo.haha.Disjunction
	 * @generated
	 */
	EClass getDisjunction();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Conjunction <em>Conjunction</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Conjunction</em>'.
	 * @see net.afyre.haha.demo.haha.Conjunction
	 * @generated
	 */
	EClass getConjunction();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Negation <em>Negation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Negation</em>'.
	 * @see net.afyre.haha.demo.haha.Negation
	 * @generated
	 */
	EClass getNegation();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Eq <em>Eq</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Eq</em>'.
	 * @see net.afyre.haha.demo.haha.Eq
	 * @generated
	 */
	EClass getEq();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Neq <em>Neq</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Neq</em>'.
	 * @see net.afyre.haha.demo.haha.Neq
	 * @generated
	 */
	EClass getNeq();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Lt <em>Lt</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Lt</em>'.
	 * @see net.afyre.haha.demo.haha.Lt
	 * @generated
	 */
	EClass getLt();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Le <em>Le</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Le</em>'.
	 * @see net.afyre.haha.demo.haha.Le
	 * @generated
	 */
	EClass getLe();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Gt <em>Gt</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Gt</em>'.
	 * @see net.afyre.haha.demo.haha.Gt
	 * @generated
	 */
	EClass getGt();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Ge <em>Ge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Ge</em>'.
	 * @see net.afyre.haha.demo.haha.Ge
	 * @generated
	 */
	EClass getGe();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Add <em>Add</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Add</em>'.
	 * @see net.afyre.haha.demo.haha.Add
	 * @generated
	 */
	EClass getAdd();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Sub <em>Sub</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Sub</em>'.
	 * @see net.afyre.haha.demo.haha.Sub
	 * @generated
	 */
	EClass getSub();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Mult <em>Mult</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Mult</em>'.
	 * @see net.afyre.haha.demo.haha.Mult
	 * @generated
	 */
	EClass getMult();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Div <em>Div</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Div</em>'.
	 * @see net.afyre.haha.demo.haha.Div
	 * @generated
	 */
	EClass getDiv();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Mod <em>Mod</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Mod</em>'.
	 * @see net.afyre.haha.demo.haha.Mod
	 * @generated
	 */
	EClass getMod();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Uminus <em>Uminus</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Uminus</em>'.
	 * @see net.afyre.haha.demo.haha.Uminus
	 * @generated
	 */
	EClass getUminus();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Var <em>Var</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Var</em>'.
	 * @see net.afyre.haha.demo.haha.Var
	 * @generated
	 */
	EClass getVar();

	/**
	 * Returns the meta object for the reference '{@link net.afyre.haha.demo.haha.Var#getSymbol <em>Symbol</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Symbol</em>'.
	 * @see net.afyre.haha.demo.haha.Var#getSymbol()
	 * @see #getVar()
	 * @generated
	 */
	EReference getVar_Symbol();

	/**
	 * Returns the meta object for the '{@link net.afyre.haha.demo.haha.Var#getName() <em>Get Name</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Get Name</em>' operation.
	 * @see net.afyre.haha.demo.haha.Var#getName()
	 * @generated
	 */
	EOperation getVar__GetName();

	/**
	 * Returns the meta object for the '{@link net.afyre.haha.demo.haha.Var#getType() <em>Get Type</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Get Type</em>' operation.
	 * @see net.afyre.haha.demo.haha.Var#getType()
	 * @generated
	 */
	EOperation getVar__GetType();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Call <em>Call</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Call</em>'.
	 * @see net.afyre.haha.demo.haha.Call
	 * @generated
	 */
	EClass getCall();

	/**
	 * Returns the meta object for the reference '{@link net.afyre.haha.demo.haha.Call#getFunction <em>Function</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Function</em>'.
	 * @see net.afyre.haha.demo.haha.Call#getFunction()
	 * @see #getCall()
	 * @generated
	 */
	EReference getCall_Function();

	/**
	 * Returns the meta object for the containment reference '{@link net.afyre.haha.demo.haha.Call#getArgs <em>Args</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Args</em>'.
	 * @see net.afyre.haha.demo.haha.Call#getArgs()
	 * @see #getCall()
	 * @generated
	 */
	EReference getCall_Args();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.ArrayAccess <em>Array Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Array Access</em>'.
	 * @see net.afyre.haha.demo.haha.ArrayAccess
	 * @generated
	 */
	EClass getArrayAccess();

	/**
	 * Returns the meta object for the containment reference '{@link net.afyre.haha.demo.haha.ArrayAccess#getArray <em>Array</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Array</em>'.
	 * @see net.afyre.haha.demo.haha.ArrayAccess#getArray()
	 * @see #getArrayAccess()
	 * @generated
	 */
	EReference getArrayAccess_Array();

	/**
	 * Returns the meta object for the containment reference list '{@link net.afyre.haha.demo.haha.ArrayAccess#getPath <em>Path</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Path</em>'.
	 * @see net.afyre.haha.demo.haha.ArrayAccess#getPath()
	 * @see #getArrayAccess()
	 * @generated
	 */
	EReference getArrayAccess_Path();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Callable <em>Callable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Callable</em>'.
	 * @see net.afyre.haha.demo.haha.Callable
	 * @generated
	 */
	EClass getCallable();

	/**
	 * Returns the meta object for the containment reference '{@link net.afyre.haha.demo.haha.Callable#getArguments <em>Arguments</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Arguments</em>'.
	 * @see net.afyre.haha.demo.haha.Callable#getArguments()
	 * @see #getCallable()
	 * @generated
	 */
	EReference getCallable_Arguments();

	/**
	 * Returns the meta object for the attribute '{@link net.afyre.haha.demo.haha.Callable#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see net.afyre.haha.demo.haha.Callable#getName()
	 * @see #getCallable()
	 * @generated
	 */
	EAttribute getCallable_Name();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Assignable <em>Assignable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Assignable</em>'.
	 * @see net.afyre.haha.demo.haha.Assignable
	 * @generated
	 */
	EClass getAssignable();

	/**
	 * Returns the meta object for the '{@link net.afyre.haha.demo.haha.Assignable#getType() <em>Get Type</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Get Type</em>' operation.
	 * @see net.afyre.haha.demo.haha.Assignable#getType()
	 * @generated
	 */
	EOperation getAssignable__GetType();

	/**
	 * Returns the meta object for the '{@link net.afyre.haha.demo.haha.Assignable#getName() <em>Get Name</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Get Name</em>' operation.
	 * @see net.afyre.haha.demo.haha.Assignable#getName()
	 * @generated
	 */
	EOperation getAssignable__GetName();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.ResultVar <em>Result Var</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Result Var</em>'.
	 * @see net.afyre.haha.demo.haha.ResultVar
	 * @generated
	 */
	EClass getResultVar();

	/**
	 * Returns the meta object for the reference '{@link net.afyre.haha.demo.haha.ResultVar#getFunction <em>Function</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Function</em>'.
	 * @see net.afyre.haha.demo.haha.ResultVar#getFunction()
	 * @see #getResultVar()
	 * @generated
	 */
	EReference getResultVar_Function();

	/**
	 * Returns the meta object for the '{@link net.afyre.haha.demo.haha.ResultVar#getName() <em>Get Name</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Get Name</em>' operation.
	 * @see net.afyre.haha.demo.haha.ResultVar#getName()
	 * @generated
	 */
	EOperation getResultVar__GetName();

	/**
	 * Returns the meta object for the '{@link net.afyre.haha.demo.haha.ResultVar#getType() <em>Get Type</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Get Type</em>' operation.
	 * @see net.afyre.haha.demo.haha.ResultVar#getType()
	 * @generated
	 */
	EOperation getResultVar__GetType();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Variable <em>Variable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Variable</em>'.
	 * @see net.afyre.haha.demo.haha.Variable
	 * @generated
	 */
	EClass getVariable();

	/**
	 * Returns the meta object for the '{@link net.afyre.haha.demo.haha.Variable#getType() <em>Get Type</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Get Type</em>' operation.
	 * @see net.afyre.haha.demo.haha.Variable#getType()
	 * @generated
	 */
	EOperation getVariable__GetType();

	/**
	 * Returns the meta object for the '{@link net.afyre.haha.demo.haha.Variable#getName() <em>Get Name</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Get Name</em>' operation.
	 * @see net.afyre.haha.demo.haha.Variable#getName()
	 * @generated
	 */
	EOperation getVariable__GetName();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.SimpleStatement <em>Simple Statement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Simple Statement</em>'.
	 * @see net.afyre.haha.demo.haha.SimpleStatement
	 * @generated
	 */
	EClass getSimpleStatement();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Power <em>Power</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Power</em>'.
	 * @see net.afyre.haha.demo.haha.Power
	 * @generated
	 */
	EClass getPower();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Axiom <em>Axiom</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Axiom</em>'.
	 * @see net.afyre.haha.demo.haha.Axiom
	 * @generated
	 */
	EClass getAxiom();

	/**
	 * Returns the meta object for the attribute '{@link net.afyre.haha.demo.haha.Axiom#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see net.afyre.haha.demo.haha.Axiom#getName()
	 * @see #getAxiom()
	 * @generated
	 */
	EAttribute getAxiom_Name();

	/**
	 * Returns the meta object for the containment reference '{@link net.afyre.haha.demo.haha.Axiom#getFormula <em>Formula</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Formula</em>'.
	 * @see net.afyre.haha.demo.haha.Axiom#getFormula()
	 * @see #getAxiom()
	 * @generated
	 */
	EReference getAxiom_Formula();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.Quantifier <em>Quantifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Quantifier</em>'.
	 * @see net.afyre.haha.demo.haha.Quantifier
	 * @generated
	 */
	EClass getQuantifier();

	/**
	 * Returns the meta object for the containment reference list '{@link net.afyre.haha.demo.haha.Quantifier#getVars <em>Vars</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Vars</em>'.
	 * @see net.afyre.haha.demo.haha.Quantifier#getVars()
	 * @see #getQuantifier()
	 * @generated
	 */
	EReference getQuantifier_Vars();

	/**
	 * Returns the meta object for the containment reference list '{@link net.afyre.haha.demo.haha.Quantifier#getPatterns <em>Patterns</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Patterns</em>'.
	 * @see net.afyre.haha.demo.haha.Quantifier#getPatterns()
	 * @see #getQuantifier()
	 * @generated
	 */
	EReference getQuantifier_Patterns();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.ExistsVar <em>Exists Var</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Exists Var</em>'.
	 * @see net.afyre.haha.demo.haha.ExistsVar
	 * @generated
	 */
	EClass getExistsVar();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.ForallVar <em>Forall Var</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Forall Var</em>'.
	 * @see net.afyre.haha.demo.haha.ForallVar
	 * @generated
	 */
	EClass getForallVar();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.AssertionList <em>Assertion List</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Assertion List</em>'.
	 * @see net.afyre.haha.demo.haha.AssertionList
	 * @generated
	 */
	EClass getAssertionList();

	/**
	 * Returns the meta object for the containment reference list '{@link net.afyre.haha.demo.haha.AssertionList#getAssertions <em>Assertions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Assertions</em>'.
	 * @see net.afyre.haha.demo.haha.AssertionList#getAssertions()
	 * @see #getAssertionList()
	 * @generated
	 */
	EReference getAssertionList_Assertions();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.HoareTriple <em>Hoare Triple</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hoare Triple</em>'.
	 * @see net.afyre.haha.demo.haha.HoareTriple
	 * @generated
	 */
	EClass getHoareTriple();

	/**
	 * Returns the meta object for the containment reference '{@link net.afyre.haha.demo.haha.HoareTriple#getPrecondition <em>Precondition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Precondition</em>'.
	 * @see net.afyre.haha.demo.haha.HoareTriple#getPrecondition()
	 * @see #getHoareTriple()
	 * @generated
	 */
	EReference getHoareTriple_Precondition();

	/**
	 * Returns the meta object for the containment reference '{@link net.afyre.haha.demo.haha.HoareTriple#getStatement <em>Statement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Statement</em>'.
	 * @see net.afyre.haha.demo.haha.HoareTriple#getStatement()
	 * @see #getHoareTriple()
	 * @generated
	 */
	EReference getHoareTriple_Statement();

	/**
	 * Returns the meta object for the containment reference '{@link net.afyre.haha.demo.haha.HoareTriple#getPostcondition <em>Postcondition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Postcondition</em>'.
	 * @see net.afyre.haha.demo.haha.HoareTriple#getPostcondition()
	 * @see #getHoareTriple()
	 * @generated
	 */
	EReference getHoareTriple_Postcondition();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.CompositeStatement <em>Composite Statement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Composite Statement</em>'.
	 * @see net.afyre.haha.demo.haha.CompositeStatement
	 * @generated
	 */
	EClass getCompositeStatement();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.CounterVariable <em>Counter Variable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Counter Variable</em>'.
	 * @see net.afyre.haha.demo.haha.CounterVariable
	 * @generated
	 */
	EClass getCounterVariable();

	/**
	 * Returns the meta object for class '{@link net.afyre.haha.demo.haha.LoopCounter <em>Loop Counter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Loop Counter</em>'.
	 * @see net.afyre.haha.demo.haha.LoopCounter
	 * @generated
	 */
	EClass getLoopCounter();

	/**
	 * Returns the meta object for the containment reference '{@link net.afyre.haha.demo.haha.LoopCounter#getVariable <em>Variable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Variable</em>'.
	 * @see net.afyre.haha.demo.haha.LoopCounter#getVariable()
	 * @see #getLoopCounter()
	 * @generated
	 */
	EReference getLoopCounter_Variable();

	/**
	 * Returns the meta object for the containment reference '{@link net.afyre.haha.demo.haha.LoopCounter#getFormula <em>Formula</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Formula</em>'.
	 * @see net.afyre.haha.demo.haha.LoopCounter#getFormula()
	 * @see #getLoopCounter()
	 * @generated
	 */
	EReference getLoopCounter_Formula();

	/**
	 * Returns the meta object for the containment reference '{@link net.afyre.haha.demo.haha.LoopCounter#getNewValue <em>New Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>New Value</em>'.
	 * @see net.afyre.haha.demo.haha.LoopCounter#getNewValue()
	 * @see #getLoopCounter()
	 * @generated
	 */
	EReference getLoopCounter_NewValue();

	/**
	 * Returns the meta object for enum '{@link net.afyre.haha.demo.haha.PrimitiveType <em>Primitive Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Primitive Type</em>'.
	 * @see net.afyre.haha.demo.haha.PrimitiveType
	 * @generated
	 */
	EEnum getPrimitiveType();

	/**
	 * Returns the meta object for enum '{@link net.afyre.haha.demo.haha.Bool <em>Bool</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Bool</em>'.
	 * @see net.afyre.haha.demo.haha.Bool
	 * @generated
	 */
	EEnum getBool();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	HahaFactory getHahaFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each operation of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.ProgramImpl <em>Program</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.ProgramImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getProgram()
		 * @generated
		 */
		EClass PROGRAM = eINSTANCE.getProgram();

		/**
		 * The meta object literal for the '<em><b>Predicates</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROGRAM__PREDICATES = eINSTANCE.getProgram_Predicates();

		/**
		 * The meta object literal for the '<em><b>Functions</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROGRAM__FUNCTIONS = eINSTANCE.getProgram_Functions();

		/**
		 * The meta object literal for the '<em><b>Axioms</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROGRAM__AXIOMS = eINSTANCE.getProgram_Axioms();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.PredicateImpl <em>Predicate</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.PredicateImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getPredicate()
		 * @generated
		 */
		EClass PREDICATE = eINSTANCE.getPredicate();

		/**
		 * The meta object literal for the '<em><b>Formula</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PREDICATE__FORMULA = eINSTANCE.getPredicate_Formula();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.FunctionImpl <em>Function</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.FunctionImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getFunction()
		 * @generated
		 */
		EClass FUNCTION = eINSTANCE.getFunction();

		/**
		 * The meta object literal for the '<em><b>Result Type</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FUNCTION__RESULT_TYPE = eINSTANCE.getFunction_ResultType();

		/**
		 * The meta object literal for the '<em><b>Docs</b></em>' attribute list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FUNCTION__DOCS = eINSTANCE.getFunction_Docs();

		/**
		 * The meta object literal for the '<em><b>Preconditions</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FUNCTION__PRECONDITIONS = eINSTANCE.getFunction_Preconditions();

		/**
		 * The meta object literal for the '<em><b>Postconditions</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FUNCTION__POSTCONDITIONS = eINSTANCE.getFunction_Postconditions();

		/**
		 * The meta object literal for the '<em><b>Locals</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FUNCTION__LOCALS = eINSTANCE.getFunction_Locals();

		/**
		 * The meta object literal for the '<em><b>Body</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FUNCTION__BODY = eINSTANCE.getFunction_Body();

		/**
		 * The meta object literal for the '<em><b>Result Var</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FUNCTION__RESULT_VAR = eINSTANCE.getFunction_ResultVar();

		/**
		 * The meta object literal for the '<em><b>Result Var</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation FUNCTION___RESULT_VAR = eINSTANCE.getFunction__ResultVar();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.ArgumentListImpl <em>Argument List</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.ArgumentListImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getArgumentList()
		 * @generated
		 */
		EClass ARGUMENT_LIST = eINSTANCE.getArgumentList();

		/**
		 * The meta object literal for the '<em><b>Arguments</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ARGUMENT_LIST__ARGUMENTS = eINSTANCE.getArgumentList_Arguments();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.ArgumentImpl <em>Argument</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.ArgumentImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getArgument()
		 * @generated
		 */
		EClass ARGUMENT = eINSTANCE.getArgument();

		/**
		 * The meta object literal for the '<em><b>Doc</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ARGUMENT__DOC = eINSTANCE.getArgument_Doc();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.PreconditionImpl <em>Precondition</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.PreconditionImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getPrecondition()
		 * @generated
		 */
		EClass PRECONDITION = eINSTANCE.getPrecondition();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PRECONDITION__NAME = eINSTANCE.getPrecondition_Name();

		/**
		 * The meta object literal for the '<em><b>Formula</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PRECONDITION__FORMULA = eINSTANCE.getPrecondition_Formula();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.PostconditionImpl <em>Postcondition</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.PostconditionImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getPostcondition()
		 * @generated
		 */
		EClass POSTCONDITION = eINSTANCE.getPostcondition();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute POSTCONDITION__NAME = eINSTANCE.getPostcondition_Name();

		/**
		 * The meta object literal for the '<em><b>Formula</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference POSTCONDITION__FORMULA = eINSTANCE.getPostcondition_Formula();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.LocalsImpl <em>Locals</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.LocalsImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getLocals()
		 * @generated
		 */
		EClass LOCALS = eINSTANCE.getLocals();

		/**
		 * The meta object literal for the '<em><b>Variables</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LOCALS__VARIABLES = eINSTANCE.getLocals_Variables();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.LocalImpl <em>Local</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.LocalImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getLocal()
		 * @generated
		 */
		EClass LOCAL = eINSTANCE.getLocal();

		/**
		 * The meta object literal for the '<em><b>Doc</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute LOCAL__DOC = eINSTANCE.getLocal_Doc();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.TypeImpl <em>Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.TypeImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getType()
		 * @generated
		 */
		EClass TYPE = eINSTANCE.getType();

		/**
		 * The meta object literal for the '<em><b>As String</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation TYPE___AS_STRING = eINSTANCE.getType__AsString();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.SimpleTypeImpl <em>Simple Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.SimpleTypeImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getSimpleType()
		 * @generated
		 */
		EClass SIMPLE_TYPE = eINSTANCE.getSimpleType();

		/**
		 * The meta object literal for the '<em><b>Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SIMPLE_TYPE__TYPE = eINSTANCE.getSimpleType_Type();

		/**
		 * The meta object literal for the '<em><b>As String</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation SIMPLE_TYPE___AS_STRING = eINSTANCE.getSimpleType__AsString();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.ArrayTypeImpl <em>Array Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.ArrayTypeImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getArrayType()
		 * @generated
		 */
		EClass ARRAY_TYPE = eINSTANCE.getArrayType();

		/**
		 * The meta object literal for the '<em><b>Element Type</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ARRAY_TYPE__ELEMENT_TYPE = eINSTANCE.getArrayType_ElementType();

		/**
		 * The meta object literal for the '<em><b>As String</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ARRAY_TYPE___AS_STRING = eINSTANCE.getArrayType__AsString();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.StatementImpl <em>Statement</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.StatementImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getStatement()
		 * @generated
		 */
		EClass STATEMENT = eINSTANCE.getStatement();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.BlockImpl <em>Block</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.BlockImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getBlock()
		 * @generated
		 */
		EClass BLOCK = eINSTANCE.getBlock();

		/**
		 * The meta object literal for the '<em><b>Statements</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BLOCK__STATEMENTS = eINSTANCE.getBlock_Statements();

		/**
		 * The meta object literal for the '<em><b>Midconditions</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BLOCK__MIDCONDITIONS = eINSTANCE.getBlock_Midconditions();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.AssertionImpl <em>Assertion</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.AssertionImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getAssertion()
		 * @generated
		 */
		EClass ASSERTION = eINSTANCE.getAssertion();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ASSERTION__NAME = eINSTANCE.getAssertion_Name();

		/**
		 * The meta object literal for the '<em><b>Formula</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ASSERTION__FORMULA = eINSTANCE.getAssertion_Formula();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.SkipImpl <em>Skip</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.SkipImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getSkip()
		 * @generated
		 */
		EClass SKIP = eINSTANCE.getSkip();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.AssignmentImpl <em>Assignment</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.AssignmentImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getAssignment()
		 * @generated
		 */
		EClass ASSIGNMENT = eINSTANCE.getAssignment();

		/**
		 * The meta object literal for the '<em><b>Target</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ASSIGNMENT__TARGET = eINSTANCE.getAssignment_Target();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ASSIGNMENT__VALUE = eINSTANCE.getAssignment_Value();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.LValueImpl <em>LValue</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.LValueImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getLValue()
		 * @generated
		 */
		EClass LVALUE = eINSTANCE.getLValue();

		/**
		 * The meta object literal for the '<em><b>Variable</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LVALUE__VARIABLE = eINSTANCE.getLValue_Variable();

		/**
		 * The meta object literal for the '<em><b>Array Ref</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute LVALUE__ARRAY_REF = eINSTANCE.getLValue_ArrayRef();

		/**
		 * The meta object literal for the '<em><b>Path</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LVALUE__PATH = eINSTANCE.getLValue_Path();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.CondImpl <em>Cond</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.CondImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getCond()
		 * @generated
		 */
		EClass COND = eINSTANCE.getCond();

		/**
		 * The meta object literal for the '<em><b>Condition</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COND__CONDITION = eINSTANCE.getCond_Condition();

		/**
		 * The meta object literal for the '<em><b>If True</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COND__IF_TRUE = eINSTANCE.getCond_IfTrue();

		/**
		 * The meta object literal for the '<em><b>If False</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COND__IF_FALSE = eINSTANCE.getCond_IfFalse();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.LoopImpl <em>Loop</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.LoopImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getLoop()
		 * @generated
		 */
		EClass LOOP = eINSTANCE.getLoop();

		/**
		 * The meta object literal for the '<em><b>Condition</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LOOP__CONDITION = eINSTANCE.getLoop_Condition();

		/**
		 * The meta object literal for the '<em><b>Invariants</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LOOP__INVARIANTS = eINSTANCE.getLoop_Invariants();

		/**
		 * The meta object literal for the '<em><b>Body</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LOOP__BODY = eINSTANCE.getLoop_Body();

		/**
		 * The meta object literal for the '<em><b>Counter</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LOOP__COUNTER = eINSTANCE.getLoop_Counter();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.LoopInvariantImpl <em>Loop Invariant</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.LoopInvariantImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getLoopInvariant()
		 * @generated
		 */
		EClass LOOP_INVARIANT = eINSTANCE.getLoopInvariant();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute LOOP_INVARIANT__NAME = eINSTANCE.getLoopInvariant_Name();

		/**
		 * The meta object literal for the '<em><b>Formula</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LOOP_INVARIANT__FORMULA = eINSTANCE.getLoopInvariant_Formula();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.ExpressionImpl <em>Expression</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.ExpressionImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getExpression()
		 * @generated
		 */
		EClass EXPRESSION = eINSTANCE.getExpression();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.QuantifiedVarImpl <em>Quantified Var</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.QuantifiedVarImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getQuantifiedVar()
		 * @generated
		 */
		EClass QUANTIFIED_VAR = eINSTANCE.getQuantifiedVar();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.ActualArgsImpl <em>Actual Args</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.ActualArgsImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getActualArgs()
		 * @generated
		 */
		EClass ACTUAL_ARGS = eINSTANCE.getActualArgs();

		/**
		 * The meta object literal for the '<em><b>Arguments</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ACTUAL_ARGS__ARGUMENTS = eINSTANCE.getActualArgs_Arguments();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.IntLiteralImpl <em>Int Literal</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.IntLiteralImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getIntLiteral()
		 * @generated
		 */
		EClass INT_LITERAL = eINSTANCE.getIntLiteral();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute INT_LITERAL__VALUE = eINSTANCE.getIntLiteral_Value();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.DeclaredVariableImpl <em>Declared Variable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.DeclaredVariableImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getDeclaredVariable()
		 * @generated
		 */
		EClass DECLARED_VARIABLE = eINSTANCE.getDeclaredVariable();

		/**
		 * The meta object literal for the '<em><b>Type</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DECLARED_VARIABLE__TYPE = eINSTANCE.getDeclaredVariable_Type();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DECLARED_VARIABLE__NAME = eINSTANCE.getDeclaredVariable_Name();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.BoolLiteralImpl <em>Bool Literal</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.BoolLiteralImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getBoolLiteral()
		 * @generated
		 */
		EClass BOOL_LITERAL = eINSTANCE.getBoolLiteral();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BOOL_LITERAL__VALUE = eINSTANCE.getBoolLiteral_Value();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.BinaryOpImpl <em>Binary Op</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.BinaryOpImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getBinaryOp()
		 * @generated
		 */
		EClass BINARY_OP = eINSTANCE.getBinaryOp();

		/**
		 * The meta object literal for the '<em><b>Left</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BINARY_OP__LEFT = eINSTANCE.getBinaryOp_Left();

		/**
		 * The meta object literal for the '<em><b>Right</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BINARY_OP__RIGHT = eINSTANCE.getBinaryOp_Right();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.BinaryArithOpImpl <em>Binary Arith Op</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.BinaryArithOpImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getBinaryArithOp()
		 * @generated
		 */
		EClass BINARY_ARITH_OP = eINSTANCE.getBinaryArithOp();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.BinaryBoolOpImpl <em>Binary Bool Op</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.BinaryBoolOpImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getBinaryBoolOp()
		 * @generated
		 */
		EClass BINARY_BOOL_OP = eINSTANCE.getBinaryBoolOp();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.UnaryOpImpl <em>Unary Op</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.UnaryOpImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getUnaryOp()
		 * @generated
		 */
		EClass UNARY_OP = eINSTANCE.getUnaryOp();

		/**
		 * The meta object literal for the '<em><b>Arg</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference UNARY_OP__ARG = eINSTANCE.getUnaryOp_Arg();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.UnaryArithOpImpl <em>Unary Arith Op</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.UnaryArithOpImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getUnaryArithOp()
		 * @generated
		 */
		EClass UNARY_ARITH_OP = eINSTANCE.getUnaryArithOp();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.UnaryBoolOpImpl <em>Unary Bool Op</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.UnaryBoolOpImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getUnaryBoolOp()
		 * @generated
		 */
		EClass UNARY_BOOL_OP = eINSTANCE.getUnaryBoolOp();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.ComparisonOpImpl <em>Comparison Op</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.ComparisonOpImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getComparisonOp()
		 * @generated
		 */
		EClass COMPARISON_OP = eINSTANCE.getComparisonOp();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.EquivalenceImpl <em>Equivalence</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.EquivalenceImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getEquivalence()
		 * @generated
		 */
		EClass EQUIVALENCE = eINSTANCE.getEquivalence();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.ImplicationImpl <em>Implication</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.ImplicationImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getImplication()
		 * @generated
		 */
		EClass IMPLICATION = eINSTANCE.getImplication();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.ForallImpl <em>Forall</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.ForallImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getForall()
		 * @generated
		 */
		EClass FORALL = eINSTANCE.getForall();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.ExistsImpl <em>Exists</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.ExistsImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getExists()
		 * @generated
		 */
		EClass EXISTS = eINSTANCE.getExists();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.DisjunctionImpl <em>Disjunction</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.DisjunctionImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getDisjunction()
		 * @generated
		 */
		EClass DISJUNCTION = eINSTANCE.getDisjunction();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.ConjunctionImpl <em>Conjunction</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.ConjunctionImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getConjunction()
		 * @generated
		 */
		EClass CONJUNCTION = eINSTANCE.getConjunction();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.NegationImpl <em>Negation</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.NegationImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getNegation()
		 * @generated
		 */
		EClass NEGATION = eINSTANCE.getNegation();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.EqImpl <em>Eq</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.EqImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getEq()
		 * @generated
		 */
		EClass EQ = eINSTANCE.getEq();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.NeqImpl <em>Neq</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.NeqImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getNeq()
		 * @generated
		 */
		EClass NEQ = eINSTANCE.getNeq();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.LtImpl <em>Lt</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.LtImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getLt()
		 * @generated
		 */
		EClass LT = eINSTANCE.getLt();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.LeImpl <em>Le</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.LeImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getLe()
		 * @generated
		 */
		EClass LE = eINSTANCE.getLe();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.GtImpl <em>Gt</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.GtImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getGt()
		 * @generated
		 */
		EClass GT = eINSTANCE.getGt();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.GeImpl <em>Ge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.GeImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getGe()
		 * @generated
		 */
		EClass GE = eINSTANCE.getGe();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.AddImpl <em>Add</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.AddImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getAdd()
		 * @generated
		 */
		EClass ADD = eINSTANCE.getAdd();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.SubImpl <em>Sub</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.SubImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getSub()
		 * @generated
		 */
		EClass SUB = eINSTANCE.getSub();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.MultImpl <em>Mult</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.MultImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getMult()
		 * @generated
		 */
		EClass MULT = eINSTANCE.getMult();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.DivImpl <em>Div</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.DivImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getDiv()
		 * @generated
		 */
		EClass DIV = eINSTANCE.getDiv();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.ModImpl <em>Mod</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.ModImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getMod()
		 * @generated
		 */
		EClass MOD = eINSTANCE.getMod();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.UminusImpl <em>Uminus</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.UminusImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getUminus()
		 * @generated
		 */
		EClass UMINUS = eINSTANCE.getUminus();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.VarImpl <em>Var</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.VarImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getVar()
		 * @generated
		 */
		EClass VAR = eINSTANCE.getVar();

		/**
		 * The meta object literal for the '<em><b>Symbol</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference VAR__SYMBOL = eINSTANCE.getVar_Symbol();

		/**
		 * The meta object literal for the '<em><b>Get Name</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation VAR___GET_NAME = eINSTANCE.getVar__GetName();

		/**
		 * The meta object literal for the '<em><b>Get Type</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation VAR___GET_TYPE = eINSTANCE.getVar__GetType();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.CallImpl <em>Call</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.CallImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getCall()
		 * @generated
		 */
		EClass CALL = eINSTANCE.getCall();

		/**
		 * The meta object literal for the '<em><b>Function</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CALL__FUNCTION = eINSTANCE.getCall_Function();

		/**
		 * The meta object literal for the '<em><b>Args</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CALL__ARGS = eINSTANCE.getCall_Args();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.ArrayAccessImpl <em>Array Access</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.ArrayAccessImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getArrayAccess()
		 * @generated
		 */
		EClass ARRAY_ACCESS = eINSTANCE.getArrayAccess();

		/**
		 * The meta object literal for the '<em><b>Array</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ARRAY_ACCESS__ARRAY = eINSTANCE.getArrayAccess_Array();

		/**
		 * The meta object literal for the '<em><b>Path</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ARRAY_ACCESS__PATH = eINSTANCE.getArrayAccess_Path();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.CallableImpl <em>Callable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.CallableImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getCallable()
		 * @generated
		 */
		EClass CALLABLE = eINSTANCE.getCallable();

		/**
		 * The meta object literal for the '<em><b>Arguments</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CALLABLE__ARGUMENTS = eINSTANCE.getCallable_Arguments();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CALLABLE__NAME = eINSTANCE.getCallable_Name();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.Assignable <em>Assignable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.Assignable
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getAssignable()
		 * @generated
		 */
		EClass ASSIGNABLE = eINSTANCE.getAssignable();

		/**
		 * The meta object literal for the '<em><b>Get Type</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ASSIGNABLE___GET_TYPE = eINSTANCE.getAssignable__GetType();

		/**
		 * The meta object literal for the '<em><b>Get Name</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ASSIGNABLE___GET_NAME = eINSTANCE.getAssignable__GetName();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.ResultVarImpl <em>Result Var</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.ResultVarImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getResultVar()
		 * @generated
		 */
		EClass RESULT_VAR = eINSTANCE.getResultVar();

		/**
		 * The meta object literal for the '<em><b>Function</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RESULT_VAR__FUNCTION = eINSTANCE.getResultVar_Function();

		/**
		 * The meta object literal for the '<em><b>Get Name</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation RESULT_VAR___GET_NAME = eINSTANCE.getResultVar__GetName();

		/**
		 * The meta object literal for the '<em><b>Get Type</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation RESULT_VAR___GET_TYPE = eINSTANCE.getResultVar__GetType();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.Variable <em>Variable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.Variable
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getVariable()
		 * @generated
		 */
		EClass VARIABLE = eINSTANCE.getVariable();

		/**
		 * The meta object literal for the '<em><b>Get Type</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation VARIABLE___GET_TYPE = eINSTANCE.getVariable__GetType();

		/**
		 * The meta object literal for the '<em><b>Get Name</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation VARIABLE___GET_NAME = eINSTANCE.getVariable__GetName();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.SimpleStatementImpl <em>Simple Statement</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.SimpleStatementImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getSimpleStatement()
		 * @generated
		 */
		EClass SIMPLE_STATEMENT = eINSTANCE.getSimpleStatement();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.PowerImpl <em>Power</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.PowerImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getPower()
		 * @generated
		 */
		EClass POWER = eINSTANCE.getPower();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.AxiomImpl <em>Axiom</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.AxiomImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getAxiom()
		 * @generated
		 */
		EClass AXIOM = eINSTANCE.getAxiom();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute AXIOM__NAME = eINSTANCE.getAxiom_Name();

		/**
		 * The meta object literal for the '<em><b>Formula</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference AXIOM__FORMULA = eINSTANCE.getAxiom_Formula();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.QuantifierImpl <em>Quantifier</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.QuantifierImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getQuantifier()
		 * @generated
		 */
		EClass QUANTIFIER = eINSTANCE.getQuantifier();

		/**
		 * The meta object literal for the '<em><b>Vars</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference QUANTIFIER__VARS = eINSTANCE.getQuantifier_Vars();

		/**
		 * The meta object literal for the '<em><b>Patterns</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference QUANTIFIER__PATTERNS = eINSTANCE.getQuantifier_Patterns();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.ExistsVarImpl <em>Exists Var</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.ExistsVarImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getExistsVar()
		 * @generated
		 */
		EClass EXISTS_VAR = eINSTANCE.getExistsVar();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.ForallVarImpl <em>Forall Var</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.ForallVarImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getForallVar()
		 * @generated
		 */
		EClass FORALL_VAR = eINSTANCE.getForallVar();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.AssertionListImpl <em>Assertion List</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.AssertionListImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getAssertionList()
		 * @generated
		 */
		EClass ASSERTION_LIST = eINSTANCE.getAssertionList();

		/**
		 * The meta object literal for the '<em><b>Assertions</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ASSERTION_LIST__ASSERTIONS = eINSTANCE.getAssertionList_Assertions();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.HoareTripleImpl <em>Hoare Triple</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.HoareTripleImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getHoareTriple()
		 * @generated
		 */
		EClass HOARE_TRIPLE = eINSTANCE.getHoareTriple();

		/**
		 * The meta object literal for the '<em><b>Precondition</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference HOARE_TRIPLE__PRECONDITION = eINSTANCE.getHoareTriple_Precondition();

		/**
		 * The meta object literal for the '<em><b>Statement</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference HOARE_TRIPLE__STATEMENT = eINSTANCE.getHoareTriple_Statement();

		/**
		 * The meta object literal for the '<em><b>Postcondition</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference HOARE_TRIPLE__POSTCONDITION = eINSTANCE.getHoareTriple_Postcondition();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.CompositeStatementImpl <em>Composite Statement</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.CompositeStatementImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getCompositeStatement()
		 * @generated
		 */
		EClass COMPOSITE_STATEMENT = eINSTANCE.getCompositeStatement();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.CounterVariableImpl <em>Counter Variable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.CounterVariableImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getCounterVariable()
		 * @generated
		 */
		EClass COUNTER_VARIABLE = eINSTANCE.getCounterVariable();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.impl.LoopCounterImpl <em>Loop Counter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.impl.LoopCounterImpl
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getLoopCounter()
		 * @generated
		 */
		EClass LOOP_COUNTER = eINSTANCE.getLoopCounter();

		/**
		 * The meta object literal for the '<em><b>Variable</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LOOP_COUNTER__VARIABLE = eINSTANCE.getLoopCounter_Variable();

		/**
		 * The meta object literal for the '<em><b>Formula</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LOOP_COUNTER__FORMULA = eINSTANCE.getLoopCounter_Formula();

		/**
		 * The meta object literal for the '<em><b>New Value</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LOOP_COUNTER__NEW_VALUE = eINSTANCE.getLoopCounter_NewValue();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.PrimitiveType <em>Primitive Type</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.PrimitiveType
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getPrimitiveType()
		 * @generated
		 */
		EEnum PRIMITIVE_TYPE = eINSTANCE.getPrimitiveType();

		/**
		 * The meta object literal for the '{@link net.afyre.haha.demo.haha.Bool <em>Bool</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.afyre.haha.demo.haha.Bool
		 * @see net.afyre.haha.demo.haha.impl.HahaPackageImpl#getBool()
		 * @generated
		 */
		EEnum BOOL = eINSTANCE.getBool();

	}

} //HahaPackage
